!
!  SPDX-License-Identifier: GPL-3.0-or-later
!  Copyright (C) 2019-2022, respective authors of MCFM.
!

c--- converts integer kcase to corresponding 6-character string
      function kcasestring(k)
      implicit none
      include 'kprocess.f'
      character(len=6):: kcasestring
      integer k

      kcasestring='failed'

      if (k == kW_only) kcasestring='W_only'
      if (k == kW_1jet) kcasestring='W_1jet'
      if (k == kWbfrmc) kcasestring='Wbfrmc'
      if (k == kW_cjet) kcasestring='W_cjet'
      if (k == kWcjet0) kcasestring='Wcjet0'
      if (k == kWbbmas) kcasestring='Wbbmas'
      if (k == kWbbbar) kcasestring='Wbbbar'
      if (k == kW_2jet) kcasestring='W_2jet'
      if (k == kW_3jet) kcasestring='W_3jet'
      if (k == kWbbjet) kcasestring='Wbbjet'
      if (k == kZ_only) kcasestring='Z_only'
      if (k == kttZbbl) kcasestring='ttZbbl'
      if (k == kZ_1jet) kcasestring='Z_1jet'
      if (k == kZ_2jet) kcasestring='Z_2jet'
      if (k == kZ_3jet) kcasestring='Z_3jet'
      if (k == kZbbmas) kcasestring='Zbbmas'
      if (k == kZbbbar) kcasestring='Zbbbar'
      if (k == kZbbjet) kcasestring='Zbbjet'
      if (k == kWWqqbr) kcasestring='WWqqbr'
      if (k == kWWnpol) kcasestring='WWnpol'
      if (k == kWW_jet) kcasestring='WW_jet'
      if (k == kWZbbar) kcasestring='WZbbar'
      if (k == kZZlept) kcasestring='ZZlept'
      if (k == kZZ_jet) kcasestring='ZZ_jet'
      if (k == kWHbbar) kcasestring='WHbbar'
      if (k == kWHgaga) kcasestring='WHgaga'
      if (k == kWH__WW) kcasestring='WH__WW'
      if (k == kWH__ZZ) kcasestring='WH__ZZ'
      if (k == kZHbbar) kcasestring='ZHbbar'
      if (k == kZHgaga) kcasestring='ZHgaga'
      if (k == kZH__WW) kcasestring='ZH__WW'
      if (k == kZH__ZZ) kcasestring='ZH__ZZ'
      if (k == kggfus0) kcasestring='ggfus0'
      if (k == kggscl0) kcasestring='ggscl0'
      if (k == kHWW_4l) kcasestring='HWW_4l'
      if (k == kHWW_tb) kcasestring='HWW_tb'
      if (k == kHWWint) kcasestring='HWWint'
      if (k == kHWWHpi) kcasestring='HWWHpi'
      if (k == kggWW4l) kcasestring='ggWW4l'
      if (k == kggWWbx) kcasestring='ggWWbx'
      if (k == kHWW2lq) kcasestring='HWW2lq'
      if (k == kHWWdkW) kcasestring='HWWdkW'
      if (k == kHZZ_4l) kcasestring='HZZ_4l'
      if (k == kHZZ_tb) kcasestring='HZZ_tb'
      if (k == kHZZint) kcasestring='HZZint'
      if (k == kHZZHpi) kcasestring='HZZHpi'
      if (k == kggZZ4l) kcasestring='ggZZ4l'
      if (k == kggZZbx) kcasestring='ggZZbx'
      if (k == kHZZqgI) kcasestring='HZZqgI'
      if (k == kHi_Zga) kcasestring='Hi_Zga'
      if (k == kHi_Zaj) kcasestring='Hi_Zaj'
      if (k == kHVV_tb) kcasestring='HVV_tb'
      if (k == kHVVint) kcasestring='HVVint'
      if (k == kHVVHpi) kcasestring='HVVHpi'
      if (k == kggVV4l) kcasestring='ggVV4l'
      if (k == kggVVbx) kcasestring='ggVVbx'
      if (k == kH_1jet) kcasestring='H_1jet'
      if (k == ktt_bbl) kcasestring='tt_bbl'
      if (k == ktt_ldk) kcasestring='tt_ldk'
      if (k == ktt_bbu) kcasestring='tt_bbu'
      if (k == ktt_udk) kcasestring='tt_udk'
      if (k == ktt_bbh) kcasestring='tt_bbh'
      if (k == ktt_hdk) kcasestring='tt_hdk'
      if (k == ktthWdk) kcasestring='tthWdk'
      if (k == kqq_ttg) kcasestring='qq_ttg'
      if (k == ktt_tot) kcasestring='tt_tot'
      if (k == kbb_tot) kcasestring='bb_tot'
      if (k == kcc_tot) kcasestring='cc_tot'
      if (k == ktt_glu) kcasestring='tt_glu'
      if (k == kbq_tpq) kcasestring='bq_tpq'
      if (k == kbq_tpq_jet) kcasestring = 'bqtpqj'
      if (k == kttdkay) kcasestring='ttdkay'
      if (k == kt_bbar) kcasestring='t_bbar'
      if (k == ktdecay) kcasestring='tdecay'
      if (k == kW_tndk) kcasestring='W_tndk'
      if (k == kW_twdk) kcasestring='W_twdk'
      if (k == kWtdkay) kcasestring='Wtdkay'
      if (k == kWtbwdk) kcasestring='Wtbwdk'
      if (k == kWtbndk) kcasestring='Wtbndk'
      if (k == khttjet) kcasestring='httjet'
      if (k == khttscl) kcasestring='httscl'
      if (k == kggfus1) kcasestring='ggfus1'
      if (k == khjetma) kcasestring='hjetma'
      if (k == kattjet) kcasestring='attjet'
      if (k == kHWWjet) kcasestring='HWWjet'
      if (k == kHZZjet) kcasestring='HZZjet'
      if (k == kqq_Hqq) kcasestring='qq_Hqq'
      if (k == kqq_HWW) kcasestring='qq_HWW'
      if (k == kqq_HZZ) kcasestring='qq_HZZ'
      if (k == kqq_Hgg) kcasestring='qq_Hgg'
      if (k == kqqHqqg) kcasestring='qqHqqg'
      if (k == kqqZZqq) kcasestring='qqZZqq'
      if (k == ktautau) kcasestring='tautau'
      if (k == kqqWWqq) kcasestring='qqWWqq'
      if (k == kqqVVqq) kcasestring='qqVVqq'
      if (k == kqqWWss) kcasestring='qqWWss'
      if (k == kqqWZqq) kcasestring='qqWZqq'
      if (k == kqg_tbq) kcasestring='qg_tbq'
      if (k == kqgtbqq) kcasestring='qgtbqq'
      if (k == k4ftwdk) kcasestring='4ftwdk'
      if (k == kdk_4ft) kcasestring='dk_4ft'
      if (k == k4ftjet) kcasestring='4ftjet'
      if (k == kqq_tbg) kcasestring='qq_tbg'
      if (k == kqqtbgg) kcasestring='qqtbgg'
      if (k == kepem3j) kcasestring='epem3j'
      if (k == kWpWp2j) kcasestring='WpWp2j'
      if (k == kWpWp3j) kcasestring='WpWp3j'
      if (k == kWpmZjj) kcasestring='WpmZjj'
      if (k == kWpmZbj) kcasestring='WpmZbj'
      if (k == kWpmZbb) kcasestring='WpmZbb'
      if (k == kgQ__ZQ) kcasestring='gQ__ZQ'
      if (k == kgagajj) kcasestring='gagajj'
      if (k == kggfus2) kcasestring='ggfus2'
      if (k == kHWW2jt) kcasestring='HWW2jt'
      if (k == kHZZ2jt) kcasestring='HZZ2jt'
      if (k == kggfus3) kcasestring='ggfus3'
      if (k == kHWW3jt) kcasestring='HWW3jt'
      if (k == kHZZ3jt) kcasestring='HZZ3jt'
      if (k == kdirgam) kcasestring='dirgam'
      if (k == kgamjet) kcasestring='gamjet'
      if (k == khflgam) kcasestring='hflgam'
      if (k == kgamgam) kcasestring='gamgam'
      if (k == kgmgmjt) kcasestring='gmgmjt'
      if (k == ktrigam) kcasestring='trigam'
      if (k == kgmgmjj) kcasestring='gmgmjj'
      if (k == kfourga) kcasestring='fourga'
      if (k == ktwojet) kcasestring='twojet'
      if (k == kthrjet) kcasestring='thrjet'
      if (k == kWgamma) kcasestring='Wgamma'
      if (k == kWgajet) kcasestring='Wgajet'
      if (k == kZgamma) kcasestring='Zgamma'
      if (k == kZgajet) kcasestring='Zgajet'
      if (k == kZ_2gam) kcasestring='Z_2gam'
      if (k == kZ2gajt) kcasestring='Z2gajt'
      if (k == kZga2jt) kcasestring='Zga2jt'
      if (k == kW_bjet) kcasestring='W_bjet'
      if (k == kWcjetg) kcasestring='Wcjetg'
      if (k == kZ_bjet) kcasestring='Z_bjet'
      if (k == kZbjetg) kcasestring='Zbjetg'
      if (k == kWcsbar) kcasestring='Wcsbar'
      if (k == kWcs_ms) kcasestring='Wcs_ms'
      if (k == kW_2gam) kcasestring='W_2gam'
      if (k == kWbbjem) kcasestring='Wbbjem'
      if (k == kWttmas) kcasestring='Wttmas'
      if (k == kqq_ttw) kcasestring='qq_ttw'
      if (k == kttwldk) kcasestring='ttwldk'
      if (k == kqq_ttz) kcasestring='qq_ttz'
      if (k == kqqtthz) kcasestring='qqtthz'
      if (k == kH_tjet) kcasestring='H_tjet'
      if (k == kH_tdkj) kcasestring='H_tdkj'
      if (k == kZ_tjet) kcasestring='Z_tjet'
      if (k == kZt2jet) kcasestring='Zt2jet'
      if (k == kZ_tdkj) kcasestring='Z_tdkj'
      if (k == kZtdk2j) kcasestring='Ztdk2j'
      if (k == kHHpair) kcasestring='HHpair'
      if (k == kWH1jet) kcasestring='WH1jet'
      if (k == kZH1jet) kcasestring='ZH1jet'
      if (k == ktottth) kcasestring='tottth'
      if (k == kqq_tth) kcasestring='qq_tth'
      if (k == ktth_ww) kcasestring='tth_ww'
      if (k == kdm_jet) kcasestring='dm_jet'
      if (k == kdm_gam) kcasestring='dm_gam'
      if (k == kdm2jet) kcasestring='dm2jet'
      if (k == kdm_gaj) kcasestring='dm_gaj'
      if (k == kvlchk2) kcasestring='vlchk2'
      if (k == kvlchk3) kcasestring='vlchk3'
      if (k == kvlchk4) kcasestring='vlchk4'
      if (k == kvlchk5) kcasestring='vlchk5'
      if (k == kvlchk6) kcasestring='vlchk6'
      if (k == kvlchk8) kcasestring='vlchk8'
      if (k == kvlchkm) kcasestring='vlchkm'
      if (k == kvlchm3) kcasestring='vlchm3'
      if (k == kvlchwt) kcasestring='vlchwt'
      if (k == kvlchwn) kcasestring='vlchwn'
      if (k == kvlchwg) kcasestring='vlchwg'
      if (k == kvlchwh) kcasestring='vlchwh'
      if (k == kWWqqdk) kcasestring='WWqqdk'
      if (k == kHigaga) kcasestring='Higaga'
      if (k == kdmgamj) kcasestring='dmgamj'
      if (k == kHgagaj) kcasestring='Hgagaj'
      if (k == kHZZpjt) kcasestring='HZZpjt'
      if (k == kHmZZ4l) kcasestring='HmZZ4l'
      if (k == kHZZ_jj) kcasestring='HZZ_jj'
      if (k == kW_cwdk) kcasestring='W_cwdk'
      if (k == kZccmas) kcasestring='Zccmas'
      if (k == ktotttz) kcasestring='totttz'
      if (k == kW_frag) kcasestring='W_frag'
      if (k == kWb2jet) kcasestring='Wb2jet'
      if (k == kWW2jet) kcasestring='WW2jet'
      if (k == kZ_frag) kcasestring='Z_frag'
      if (k == kqqttbb) kcasestring='qqttbb'
      if (k == kqqttgg) kcasestring='qqttgg'
      if (k == kqg_tbb) kcasestring='qg_tbb'
      if (k == kHt2jet) kcasestring='Ht2jet'
      if (k == kttbdkh) kcasestring='ttbdkh'
      if (k == kttbdkl) kcasestring='ttbdkl'
      if (k == khlljet) kcasestring='hlljet'
      if (k == kZHlept) kcasestring='ZHlept'
      if (k == kWHbbdk) kcasestring='WHbbdk'
      if (k == kZHbbdk) kcasestring='ZHbbdk'
      if (k == kgg2gam) kcasestring='gg2gam'
      if (k == kh2jmas) kcasestring='h2jmas'
      if (k == kWga2jt) kcasestring='Wga2jt'
      if (k == ktt_mix) kcasestring='tt_mix'
      if (k == ktwo_ew) kcasestring='two_ew'
      if (k == kgg2lep) kcasestring='gg2lep'
      if (k == ktopanom) kcasestring='ktanom'
      if (k == kbq_tpq_jet) kcasestring='kt_jet'
      if (k == kWZ_jet) kcasestring='WZ_jet'
      if (k == kh2jscl) kcasestring='h2jscl'
      if (k == kWgaj_a) kcasestring='Wgaj_a'
      if (k == kWga_ew) kcasestring='Wga_ew'
      if (k == kWgajew) kcasestring='Wgajew'
      if (k == kWgajja) kcasestring='Wgajja'
      if (k == kWln_ew) kcasestring='Wln_ew'
      if (k == kWln_aq) kcasestring='Wln_aq'
      if (k == kVVlept) kcasestring='VVlept'
      if (k == kgam_2j) kcasestring='gam_2j'
      if (k == kgam_3j) kcasestring='gam_3j'
      if (k == kZ2jetF) kcasestring='Z2jetF'
      if (k == kHgagaI) kcasestring='HgagaI'
      if (k == kgg2gamjt) kcasestring='gg2gjt'

      if (kcasestring == 'failed') then
        write(6,*) 'Unexpected kcase in kcasestring: ',k
        stop
      endif

      return
      end

