!
!  SPDX-License-Identifier: GPL-3.0-or-later
!  Copyright (C) 2019-2022, respective authors of MCFM.
!
*******************************************************************
*                                                                 *
*       Routine automatically generated by writeALC.frm           *
*                                                                 *
*******************************************************************
      subroutine ALC_mp(k1,k2,k3,k4,k5,k6,coeff,ampALC)
c--- This is the leading colour amplitude in the notation
c---  (q1, Qb2, Q3, qb4)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'mxpart.f'
      include 'momwbbm.f'
      include 'zprods_com.f'
      include 'Wbbmlabels.f'
      integer k1,k2,k3,k4,k5,k6,v1,v2,j,eta,k34f,k56f
      complex(dp):: ampALC(2,2)
      real(dp):: p2(4),p3(4),p23(4),p123(4),p234(4),p1234(4),
     & p12(4),p34(4),p56(4),s23,s123,s234,s34,s12,s1234,msq,mb
      complex(dp):: zab,zaba,zbab,zabab,ampLO
      real(dp):: K1f(4),K2f(4),p1Dp3,p1Dp4,p2Dp3,p2Dp4
      real(dp):: n1(4),n2(4),p3DP,etaDp3,etaDP,al1,al2,kappa
      real(dp):: S1,S2,K1DK2,den,a,b,c,lam(2),gam,tmp
      complex(dp):: a11,a12,a21,a22
      complex(dp):: be,besq
      complex(dp):: zaP2b,zaP3b,zaP12b,zaP23b,zaP34b,zaP123b,
     & zaP234b,zaP1234b
      complex(dp):: zaP2bP123a,zaP123bP3a,zaP12bP3a,zaP23bP3a,
     & zaP2bP34a,zaP234bP34a,zaP34bP2a
      complex(dp):: zbP123aP3b,zbP12aP3b,zbP23aP3b,
     & zbP34aP2b
      real(dp):: kappa1,kappa2,p3Dp12,p34Dp12
      parameter(k34f=7,k56f=8)
c--- statement functions to define zab spinor strings
      zaP2b(v1,v2)=bp*za(v1,k2)*zb(k2,v2)+bm*za(v1,k3)*zb(k3,v2)
      zaP3b(v1,v2)=bp*za(v1,k3)*zb(k3,v2)+bm*za(v1,k2)*zb(k2,v2)
      zaP12b(v1,v2)=bp*za(v1,k2)*zb(k2,v2)+bm*za(v1,k3)*zb(k3,v2)
     &             +za(v1,k1)*zb(k1,v2)
      zaP23b(v1,v2)=za(v1,k2)*zb(k2,v2)+za(v1,k3)*zb(k3,v2)
      zaP34b(v1,v2)=bp*za(v1,k3)*zb(k3,v2)+bm*za(v1,k2)*zb(k2,v2)
     &             +za(v1,k4)*zb(k4,v2)
      zaP123b(v1,v2)=za(v1,k2)*zb(k2,v2)+za(v1,k3)*zb(k3,v2)
     &              +za(v1,k1)*zb(k1,v2)
      zaP234b(v1,v2)=za(v1,k2)*zb(k2,v2)+za(v1,k3)*zb(k3,v2)
     &  +za(v1,k4)*zb(k4,v2)
      zaP1234b(v1,v2)=-za(v1,k5)*zb(k5,v2)-za(v1,k6)*zb(k6,v2)
c--- statement functions to define zaba spinor strings
      zaP2bP123a(v1,v2)=bp*za(v1,k2)*zaP123b(v2,k2)
     &                 +bm*za(v1,k3)*zaP123b(v2,k3)
      zaP123bP3a(v1,v2)=bp*zaP123b(v1,k3)*za(k3,v2)
     &                 +bm*zaP123b(v1,k2)*za(k2,v2)
      zaP12bP3a(v1,v2)=bp*zaP12b(v1,k3)*za(k3,v2)
     &                +bm*zaP12b(v1,k2)*za(k2,v2)
      zaP23bP3a(v1,v2)=bp*zaP23b(v1,k3)*za(k3,v2)
     &                +bm*zaP23b(v1,k2)*za(k2,v2)
      zaP2bP34a(v1,v2)=bp*za(v1,k2)*zaP34b(v2,k2)
     &                +bm*za(v1,k3)*zaP34b(v2,k3)
      zaP234bP34a(v1,v2)=bp*zaP234b(v1,k3)*za(k3,v2)
     &                  +bm*zaP234b(v1,k2)*za(k2,v2)
     &                  +zaP234b(v1,k4)*za(k4,v2)
      zaP34bP2a(v1,v2)=bp*zaP34b(v1,k2)*za(k2,v2)
     &                +bm*zaP34b(v1,k3)*za(k3,v2)
c--- statement functions to define zbab spinor strings
      zbP123aP3b(v1,v2)=bp*zaP123b(k3,v1)*zb(k3,v2)
     &                 +bm*zaP123b(k2,v1)*zb(k2,v2)
      zbP12aP3b(v1,v2)=bp*zaP12b(k3,v1)*zb(k3,v2)
     &                +bm*zaP12b(k2,v1)*zb(k2,v2)
      zbP23aP3b(v1,v2)=bp*zaP23b(k3,v1)*zb(k3,v2)
     &                +bm*zaP23b(k2,v1)*zb(k2,v2)
      zbP34aP2b(v1,v2)=bp*zaP34b(k2,v1)*zb(k2,v2)
     &                +bm*zaP34b(k3,v1)*zb(k3,v2)


c--- zero out all integral coefficients
      call clearcoeffs(coeff)

      p2(:)=bp*mom(k2,:)+bm*mom(k3,:)
      p3(:)=bp*mom(k3,:)+bm*mom(k2,:)
      p12(:)=mom(k1,:)+p2(:)
      p34(:)=p3(:)+mom(k4,:)
      p23(:)=p2(:)+p3(:)
      p123(:)=p23(:)+mom(k1,:)
      p234(:)=p23(:)+mom(k4,:)
      p1234(:)=p123(:)+mom(k4,:)
      p56(:)=-p1234(:)

      s23=p23(4)**2-p23(1)**2-p23(2)**2-p23(3)**2
      s123=p123(4)**2-p123(1)**2-p123(2)**2-p123(3)**2
      s234=p234(4)**2-p234(1)**2-p234(2)**2-p234(3)**2
      s34=p34(4)**2-p34(1)**2-p34(2)**2-p34(3)**2
      s12=p12(4)**2-p12(1)**2-p12(2)**2-p12(3)**2
      s1234=p1234(4)**2-p1234(1)**2-p1234(2)**2-p1234(3)**2
      p1Dp3=mom(k1,4)*p3(4)-mom(k1,1)*p3(1)
     &-mom(k1,2)*p3(2)-mom(k1,3)*p3(3)
      p2Dp4=mom(k4,4)*p2(4)-mom(k4,1)*p2(1)
     &-mom(k4,2)*p2(2)-mom(k4,3)*p2(3)
      p2Dp3=p2(4)*p3(4)-p2(1)*p3(1)
     &-p2(2)*p3(2)-p2(3)*p3(3)
      p1Dp4=mom(k1,4)*mom(k4,4)-mom(k1,1)*mom(k4,1)
     &-mom(k1,2)*mom(k4,2)-mom(k1,3)*mom(k4,3)
      msq=p2(4)**2-p2(1)**2-p2(2)**2-p2(3)**2
      mb=dsqrt(msq)
      besq=1d0-4d0*bm*bp
      be=sqrt(besq)

      amplo=(za(k1,k3)*zb(k4,k5)
     &     *(za(k6,k1)*zb(k1,k2)+za(k6,k3)*zb(k3,k2))/s123
     &      -zb(k4,k2)*za(k1,k6)
     &     *(zb(k5,k2)*za(k2,k3)+zb(k5,k4)*za(k4,k3))/s234)
     &      /s23/s1234

c---------------------------- BOXES -----------------------------------

c--- this is the (1,2,34) box

      coeff(4,d1x2x34)= + s234**(-1) * ( 1.D0/2.D0/(za(k5,k6))/(zb(k2,
     &    k3))/(zb(k5,k6))/(zbab(k4,p23,p2,k1))*za(k1,k6)*zb(k2,k4)**2*
     &    zbab(k5,p234,p2,k1) + 1.D0/2.D0/(za(k5,k6))/(zb(k2,k3))/(zb(
     &    k5,k6))/(zaP23b(k1,k4))*za(k1,k6)*zb(k2,k4)**2*zaP234b(k1,k5)
     &     )
      coeff(4,d1x2x34) = coeff(4,d1x2x34) + s234 * ( 1.D0/2.D0/(za(k5,
     &    k6))/(zb(k2,k3))/(zb(k5,k6))/(zaP23b(k4,k1))/(zbP34aP2b(k1,k1
     &    ))/(zbP34aP2b(k1,k1))/(zbab(k4,p23,p2,k1))*zb(k1,k2)**2*zbab(
     &    k4,p3,p234,k1)*zbab(k5,p234,p2,k1)*zaP2b(k6,k1) - 1.D0/2.D0/(
     &    za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))/(zbP34aP2b(k1,k1))/(
     &    zbP34aP2b(k1,k1))/(zbab(k4,p23,p2,k1))*zb(k1,k2)*zb(k1,k4)*
     &    zb(k2,k4)*zbab(k5,p234,p2,k1)*zaP2b(k6,k1) )
      coeff(4,d1x2x34) = coeff(4,d1x2x34) - 1.D0/2.D0/(za(k5,k6))/(zb(
     & k2,k3))/(zb(k5,k6))/(zaP23b(k4,k1))/(zbP34aP2b(k1,k1))/(zbab(k4,
     & p23,p2,k1))*za(k1,k6)*zb(k1,k2)**2*zbab(k4,p3,p234,k1)*zbab(k5,
     & p234,p2,k1) + 1.D0/2.D0/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))/(
     &    zbP34aP2b(k1,k1))/(zbab(k4,p23,p2,k1))*za(k1,k6)*zb(k1,k2)*
     &    zb(k1,k4)*zb(k2,k4)*zbab(k5,p234,p2,k1) - 1.D0/2.D0/(za(k5,k6
     &    ))/(zb(k2,k3))/(zb(k5,k6))/(zbP34aP2b(k1,k1))/(zbab(k4,p23,p2
     &    ,k1))*zb(k2,k4)**2*zbab(k5,p234,p2,k1)*zaP2b(k6,k1)

c--- this is the (12,3,4) box

      coeff(4,d12x3x4)= + s123**(-1) * ( 1.D0/2.D0/(za(k2,k3))/(za(k5,
     &    k6))/(zb(k5,k6))/(zaP23b(k1,k4))*za(k1,k3)**2*zb(k4,k5)*
     &    zaP123b(k6,k4) + 1.D0/2.D0/(za(k2,k3))/(za(k5,k6))/(zb(k5,k6)
     &    )/(zaP23bP3a(k1,k4))*za(k1,k3)**2*zb(k4,k5)*zaP123bP3a(k6,k4)
     &     )
      coeff(4,d12x3x4) = coeff(4,d12x3x4) + s123 * ( 1.D0/2.D0/(za(k2,
     &    k3))/(za(k5,k6))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23bP3a(k1,k4
     &    ))/(zaP12bP3a(k4,k4))/(zaP12bP3a(k4,k4))*za(k3,k4)**2*zaP3b(
     &    k4,k5)*zaP2bP123a(k1,k4)*zaP123bP3a(k6,k4) + 1.D0/2.D0/(za(k2
     &    ,k3))/(za(k5,k6))/(zb(k5,k6))/(zaP23bP3a(k1,k4))/(zaP12bP3a(
     &    k4,k4))/(zaP12bP3a(k4,k4))*za(k1,k3)*za(k1,k4)*za(k3,k4)*
     &    zaP3b(k4,k5)*zaP123bP3a(k6,k4) )
      coeff(4,d12x3x4) = coeff(4,d12x3x4) - 1.D0/2.D0/(za(k2,k3))/(za(
     & k5,k6))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23bP3a(k1,k4))/(
     & zaP12bP3a(k4,k4))*za(k3,k4)**2*zb(k4,k5)*zaP2bP123a(k1,k4)*
     & zaP123bP3a(k6,k4) - 1.D0/2.D0/(za(k2,k3))/(za(k5,k6))/(zb(k5,k6)
     &    )/(zaP23bP3a(k1,k4))/(zaP12bP3a(k4,k4))*za(k1,k3)**2*zaP3b(k4
     &    ,k5)*zaP123bP3a(k6,k4) - 1.D0/2.D0/(za(k2,k3))/(za(k5,k6))/(
     &    zb(k5,k6))/(zaP23bP3a(k1,k4))/(zaP12bP3a(k4,k4))*za(k1,k3)*
     &    za(k1,k4)*za(k3,k4)*zb(k4,k5)*zaP123bP3a(k6,k4)

c--- this is the (1,2,3) box

      coeff(4,d1x2x3)= + s123**(-1) * (  - 1.D0/2.D0/(za(k2,k3))/(zb(k5
     &    ,k6))/(zaP23b(k1,k4))*za(k1,k3)**2*zb(k4,k5)**2 + 1.D0/2.D0/(
     &    za(k5,k6))/(zb(k1,k3))/(zb(k1,k3))/(zaP23b(k4,k1))*zb(k2,k3)*
     &    zaP2b(k6,k1)**2*be**(-2) + 1/(za(k5,k6))/(zb(k1,k3))/(zaP23b(
     &    k4,k1))*za(k1,k6)*zb(k1,k2)*zaP2b(k6,k1)*be**(-1) + 1.D0/2.D0
     &    /(za(k5,k6))/(zb(k2,k3))/(zaP23b(k4,k1))*za(k1,k6)**2*zb(k1,
     &    k2)**2 )

c--- this is the (2,3,4) box

      coeff(4,d2x3x4)= + s234**(-1) * (  - 1.D0/2.D0/(za(k2,k3))/(zb(k5
     &    ,k6))/(zaP23b(k4,k1))*za(k3,k4)**2*zb(k4,k5)**2 - 1.D0/2.D0/(
     &    za(k2,k4))/(za(k2,k4))/(zb(k5,k6))/(zaP23b(k4,k1))*za(k2,k3)*
     &    zaP3b(k4,k5)**2*be**(-2) + 1/(za(k2,k4))/(zb(k5,k6))/(zaP23b(
     &    k4,k1))*za(k3,k4)*zb(k4,k5)*zaP3b(k4,k5)*be**(-1) + 1.D0/2.D0
     &    /(za(k5,k6))/(zb(k2,k3))/(zaP23b(k1,k4))*za(k1,k6)**2*zb(k2,
     &    k4)**2 )

c-------------------------- TRIANGLES ---------------------------------

c--- this is the (23,4) triangle

       coeff(3,c23x4)= + s234**(-1) * (  - 1.D0/2.D0/(za(k2,k4))/(za(k2
     &    ,k4))/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))/(zaP23b(k4,k1))*za(
     &    k1,k6)*zaP3b(k4,k1)*zaP3b(k4,k4)*zaP23b(k4,k5)*be**(-2) - 1.D0
     &    /2.D0/(za(k2,k4))/(za(k5,k6))/(zb(k5,k6))/(zaP23b(k4,k1))/(
     &    zaP23b(k4,k1))*za(k1,k6)*za(k3,k4)*zb(k1,k4)*zaP3b(k4,k1)*
     &    zaP23b(k4,k5)*be**(-1) - 1.D0/2.D0/(za(k5,k6))/(zb(k2,k3))/(
     &    zb(k5,k6))/(zaP23b(k1,k4))*za(k1,k6)*zb(k2,k4)**2*zaP234b(k1,
     &    k5) - 1.D0/2.D0/(za(k5,k6))/(zb(k5,k6))/(zaP23b(k4,k1))/(
     &    zaP23b(k4,k1))/(zaP23b(k4,k4))*za(k1,k6)*za(k3,k4)**2*zb(k1,
     &    k4)**2*zb(k2,k3)*zaP23b(k4,k5) )
      coeff(3,c23x4) = coeff(3,c23x4) + s234 * ( 1.D0/2.D0/(za(k2,k4))
     &    /(za(k5,k6))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k1))/(
     &    zaP23b(k4,k4))*za(k3,k4)*za(k4,k6)*zb(k4,k5)*zaP3b(k4,k1)*
     &    be**(-1) + 1.D0/2.D0/(za(k2,k4))/(za(k5,k6))/(zb(k5,k6))/(
     &    zaP23b(k4,k1))/(zaP23b(k4,k4))/(zaP23b(k4,k4))*za(k3,k4)*za(
     &    k4,k6)*zb(k4,k5)*zaP2b(k4,k4)*be**(-1) + 1.D0/2.D0/(za(k5,k6)
     &    )/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k1))/(zaP23b(k4,k4))
     &    /(zaP23b(k4,k4))*za(k3,k4)**2*za(k4,k6)*zb(k1,k4)*zb(k2,k3)*
     &    zb(k4,k5) )
      coeff(3,c23x4) = coeff(3,c23x4) + 1.D0/2.D0/(za(k2,k3))/(za(k2,k4
     & ))/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))/(zaP23b(k4,k1))*za(k3,k4)
     & *zb(k4,k5)*zaba(k4,p2,p23,k6)*be**(-1) + 1.D0/2.D0/(za(k2,k3))/(
     &    za(k5,k6))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k4))*za(k1,
     &    k6)*za(k3,k4)**2*zb(k1,k4)*zb(k4,k5) - 1.D0/2.D0/(za(k2,k4))
     &    /(za(k2,k4))/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))/(zaP23b(k4,
     &    k1))/(zaP23b(k4,k1))*zaba(k4,p2,p23,k6)*zaP3b(k4,k1)*zaP23b(
     &    k4,k5)*be**(-2) + 1.D0/2.D0/(za(k2,k4))/(za(k2,k4))/(za(k5,k6
     &    ))/(zb(k2,k3))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k4))*
     &    za(k1,k6)*zaP3b(k4,k1)*zaP3b(k4,k4)*zaP23b(k4,k5)*be**(-2) - 
     &    1.D0/2.D0/(za(k2,k4))/(za(k2,k4))/(za(k5,k6))/(zb(k5,k6))/(
     &    zaP23b(k4,k1))/(zaP23b(k4,k1))/(zaP23b(k4,k4))*za(k2,k3)*za(
     &    k4,k6)*zaP2b(k4,k4)*zaP3b(k4,k1)*zaP23b(k4,k5)*be**(-2) - 1.D0
     &    /2.D0/(za(k2,k4))/(za(k2,k4))/(za(k5,k6))/(zb(k5,k6))/(
     &    zaP23b(k4,k1))/(zaP23b(k4,k1))/(zaP23b(k4,k4))*za(k2,k3)*za(
     &    k4,k6)*zaP3b(k4,k1)*zaP3b(k4,k4)*zaP23b(k4,k5)*be**(-2)
      coeff(3,c23x4) = coeff(3,c23x4) - 1.D0/2.D0/(za(k2,k4))/(za(k5,k6
     & ))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k1))/(zaP23b(k4,k1))/(
     & zaP23b(k4,k4))*za(k2,k3)*za(k3,k4)*za(k4,k6)*zb(k1,k4)*zb(k2,k3)
     & *zaP3b(k4,k1)*zaP23b(k4,k5)*be**(-1) - 1.D0/2.D0/(za(k2,k4))/(
     &    za(k5,k6))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k1))/(
     &    zaP23b(k4,k4))*za(k3,k4)*zb(k1,k4)*zaba(k4,p2,p23,k6)*zaP23b(
     &    k4,k5)*be**(-1) - 1.D0/2.D0/(za(k2,k4))/(za(k5,k6))/(zb(k5,k6
     &    ))/(zaP23b(k4,k1))/(zaP23b(k4,k1))/(zaP23b(k4,k4))/(zaP23b(k4
     &    ,k4))*za(k2,k3)*za(k3,k4)*za(k4,k6)*zb(k1,k4)*zb(k2,k3)*
     &    zaP2b(k4,k4)*zaP23b(k4,k5)*be**(-1) + 1.D0/2.D0/(za(k2,k4))/(
     &    za(k5,k6))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k4))*za(k1,
     &    k6)*za(k3,k4)*zb(k4,k5)*zaP3b(k4,k1)*be**(-1) - 1.D0/2.D0/(
     &    za(k2,k4))/(za(k5,k6))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4
     &    ,k4))*za(k3,k4)*zb(k4,k5)*zaba(k4,p2,p23,k6)*be**(-1) - 1.D0/
     &    2.D0/(za(k5,k6))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k1))
     &    /(zaP23b(k4,k1))/(zaP23b(k4,k4))/(zaP23b(k4,k4))*za(k2,k3)*
     &    za(k3,k4)**2*za(k4,k6)*zb(k1,k4)**2*zb(k2,k3)**2*zaP23b(k4,k5
     &    )

c--- identities that ensure the correct pole structure
      coeff(3,c3x4)=-(ampLO+coeff(4,d2x3x4)+coeff(4,d12x3x4))
      coeff(3,c1x2)=-(ampLO+coeff(4,d1x2x3)+coeff(4,d1x2x34))

      coeff(3,c1x23)=
     & -(coeff(4,d2x3x4)+coeff(4,d1x2x3)+coeff(3,c23x4)
     &   -2d0*coeff(4,d1x23x4))
      coeff(3,c1x234)=
     & -(coeff(4,d1x2x34)+coeff(4,d1x2x3)+coeff(3,c1x23))
      coeff(3,c123x4)=
     & -(coeff(4,d1x2x34)+coeff(4,d12x3x4)+coeff(3,c1x234)
     &   +2d0*coeff(4,d1x23x4))

c--- this is the (12,3) triangle
c---  (for this triangle, K1=-(1+2+3), K2=-3)
      S1=s123
      S2=p3(4)**2-p3(1)**2-p3(2)**2-p3(3)**2
      K1DK2=msq+p1Dp3+p2Dp3
      a=1._dp
      b=-2*K1DK2
      c=S1*S2
c      gamma=K1DK2+sqrt(K1DK2**2-S1*S2)
      call solvequadratic(a,b,c,lam(1),lam(2))

      coeff(3,c12x3)=czip
c--- loop over two solutions for lam(j)
      do j=1,2
      den=lam(j)**2-S1*S2
      a11=S1*(lam(j)-(S2-msq))/den
      a12=(S2*(lam(j)-S1)-lam(j)*msq)/den
      a21=a11-S1/lam(j)
      a22=a12-cone

      K1f(:)=lam(j)*(-lam(j)*p123(:)+S1*p3(:))/den
      K2f(:)=lam(j)*(-lam(j)*p3(:)+S2*p123(:))/den

      coeff(3,c12x3)=coeff(3,c12x3) + bp * ( 1.D0/2.D0/(zb(k2,k3))/(zb(
     &    k5,k6))/(zab(k1,K2f,k1))/(zab(k1,K2f,k4))/(zaba(k1,p123,K2f,
     &    k4))*zb(k4,k5)**2*zab(k1,K2f,k2)*zab(k4,K2f,k2)*zaba(k1,p123,
     &    K2f,k1) - 1.D0/2.D0/(zb(k2,k3))/(zb(k5,k6))/(zab(k1,K2f,k1))
     &    /(zab(k1,K2f,k4))/(zaba(k1,p123,K2f,k4))*zb(k4,k5)**2*zab(k1,
     &    K2f,k2)*zab(k4,K2f,k2)*zaba(k1,p2,K2f,k1) )
      coeff(3,c12x3) = coeff(3,c12x3) + bp**2 * (  - 1.D0/2.D0/(za(k5,
     &    k6))/(zab(k4,K1f,k1))/(zab(k4,K1f,k1))/(zbab(k1,K1f,p123,k1))
     &    *zab(k3,K1f,k1)*zab(k4,K2f,k2)*zab(k6,K1f,k1)**2*a11 - 1.D0/2.
     &    D0/(za(k5,k6))/(zab(k4,K1f,k1))/(zbab(k1,K1f,p123,k1))*zab(k3
     &    ,K1f,k1)*zab(k6,K1f,k1)*zab(k6,K1f,k2) + 1.D0/2.D0/(za(k5,k6)
     &    )/(zab(k4,K1f,k1))/(zbab(k1,K1f,p123,k1))*zab(k3,K1f,k1)*zab(
     &    k6,K1f,k1)*zab(k6,K1f,k2)*a22 + 1/(za(k5,k6))/(zab(k4,K1f,k1)
     &    )/(zbab(k1,K1f,p123,k1))*zab(k3,K1f,k1)*zab(k6,K1f,k1)*zab(k6
     &    ,K2f,k2)*a21 + 1.D0/2.D0/(za(k5,k6))/(zab(k4,K1f,k1))/(zbab(
     &    k1,K1f,p123,k1))*zab(k3,K2f,k2)*zab(k6,K1f,k1)**2*a11 - 1.D0/
     &    2.D0/(za(k5,k6))/(zab(k4,K1f,k1))/(zbab(k1,K1f,p123,k1))/(
     &    zbab(k1,K1f,p123,k1))*zab(k3,K1f,k1)*zab(k6,K1f,k1)**2*zbab(
     &    k2,K2f,p123,k1)*a11 - 1.D0/2.D0/(zb(k2,k3))/(zb(k5,k6))/(zab(
     &    k1,K2f,k1))/(zab(k1,K2f,k4))/(zab(k2,K1f,k2))/(zaba(k1,p123,
     &    K2f,k4))*za(k2,k3)*zb(k4,k5)**2*zab(k1,K1f,k2)*zab(k1,K2f,k2)
     &    *zab(k1,K2f,k3)*zab(k4,K2f,k2) )
      enddo

C--- additional normalization factor for Rodrigo
      coeff(3,c12x3)=coeff(3,c12x3)/bp

c--- this is the (2,34) triangle
c--- for this triangle, K1=-(2+3+4), K2=-2
      S1=s234
      S2=p2(4)**2-p2(1)**2-p2(2)**2-p2(3)**2
      K1DK2=msq+p2Dp4+p2Dp3
      a=1._dp
      b=-2*K1DK2
      c=S1*S2
c      gamma=K1DK2+sqrt(K1DK2**2-S1*S2)
      call solvequadratic(a,b,c,lam(1),lam(2))

      coeff(3,c2x34)=czip
c--- loop over two solutions for lam(j)
      do j=1,2
      den=lam(j)**2-S1*S2
      a11=S1*(lam(j)-(S2-msq))/den
      a12=(S2*(lam(j)-S1)-lam(j)*msq)/den
      a21=a11-S1/lam(j)
      a22=a12-cone

      K1f(:)=lam(j)*(-lam(j)*p234(:)+S1*p2(:))/den
      K2f(:)=lam(j)*(-lam(j)*p2(:)+S2*p234(:))/den

      coeff(3,c2x34)=coeff(3,c2x34) + bp * (  - 1.D0/2.D0/(za(k2,k3))/(
     &    za(k5,k6))/(zab(k1,K2f,k4))/(zab(k4,K2f,k4))/(zbab(k4,p234,
     &    K2f,k1))*za(k1,k6)**2*zab(k3,K2f,k1)*zab(k3,K2f,k4)*zbab(k4,
     &    p234,K2f,k4) + 1.D0/2.D0/(za(k2,k3))/(za(k5,k6))/(zab(k1,K2f,
     &    k4))/(zab(k4,K2f,k4))/(zbab(k4,p234,K2f,k1))*za(k1,k6)**2*
     &    zab(k3,K2f,k1)*zab(k3,K2f,k4)*zbab(k4,p3,K2f,k4) )
      coeff(3,c2x34) = coeff(3,c2x34) + bp**2 * (  - 1.D0/2.D0/(za(k2,
     &    k3))/(za(k5,k6))/(zab(k1,K2f,k4))/(zab(k3,K1f,k3))/(zab(k4,
     &    K2f,k4))/(zbab(k4,p234,K2f,k1))*za(k1,k6)**2*zb(k2,k3)*zab(k2
     &    ,K2f,k4)*zab(k3,K1f,k4)*zab(k3,K2f,k1)*zab(k3,K2f,k4) - 1.D0/
     &    2.D0/(zb(k5,k6))/(zab(k4,K1f,k1))/(zab(k4,K1f,k1))/(zaba(k4,
     &    K1f,p234,k4))*zab(k3,K2f,k1)*zab(k4,K1f,k2)*zab(k4,K1f,k5)**2
     &    *a11 - 1.D0/2.D0/(zb(k5,k6))/(zab(k4,K1f,k1))/(zaba(k4,K1f,
     &    p234,k4))*zab(k3,K1f,k5)*zab(k4,K1f,k2)*zab(k4,K1f,k5) + 1.D0/
     &    2.D0/(zb(k5,k6))/(zab(k4,K1f,k1))/(zaba(k4,K1f,p234,k4))*zab(
     &    k3,K1f,k5)*zab(k4,K1f,k2)*zab(k4,K1f,k5)*a22 + 1.D0/2.D0/(zb(
     &    k5,k6))/(zab(k4,K1f,k1))/(zaba(k4,K1f,p234,k4))*zab(k3,K2f,k2
     &    )*zab(k4,K1f,k5)**2*a11 + 1/(zb(k5,k6))/(zab(k4,K1f,k1))/(
     &    zaba(k4,K1f,p234,k4))*zab(k3,K2f,k5)*zab(k4,K1f,k2)*zab(k4,
     &    K1f,k5)*a21 - 1.D0/2.D0/(zb(k5,k6))/(zab(k4,K1f,k1))/(zaba(k4
     &    ,K1f,p234,k4))/(zaba(k4,K1f,p234,k4))*zab(k4,K1f,k2)*zab(k4,
     &    K1f,k5)**2*zaba(k3,K2f,p234,k4)*a11 )
      enddo

C--- additional normalization factor for Rodrigo
      coeff(3,c2x34)=coeff(3,c2x34)/bp

c--- this is the (12,34) triangle
c--- for this triangle, K1=-(1+2+3+4), K2=-(3+4)
      S1=s1234
      S2=s34
      K1DK2=p1Dp3+p1Dp4+p2Dp3+p2Dp4+s34
      a=1._dp
      b=-2*K1DK2
      c=S1*S2
c      gamma=K1DK2+sqrt(K1DK2**2-S1*S2)
      call solvequadratic(a,b,c,lam(1),lam(2))

      coeff(3,c12x34)=czip
c--- loop over two solutions for gamma
      do j=1,2
      den=lam(j)**2-S1*S2
      a11=S1*(lam(j)-(S2-msq))/den
      a12=(S2*(lam(j)-S1)-lam(j)*msq)/den
      a21=a11-S1/lam(j)
      a22=a12-cone

      K1f(:)=lam(j)*(-lam(j)*p1234(:)+S1*p34(:))/den
      K2f(:)=lam(j)*(-lam(j)*p34(:)+S2*p1234(:))/den

      coeff(3,c12x34)=coeff(3,c12x34) + bp * (  - 1.D0/2.D0/(za(k5,k6))
     &    /(zb(k2,k3))/(zb(k5,k6))/(zab(k1,K1f,k1))/(zab(k1,K2f,k1))/(
     &    zab(k4,K1f,k4))/(zab(k4,K2f,k4))/(zab(k4,K2f,k4))*zb(k2,k4)**
     &    2*zab(k1,K2f,k4)*zab(k4,K1f,k1)*zab(k4,K2f,k5)*zab(k6,K1f,k4)
     &    *zaba(k1,p2,K2f,k4) - 1.D0/2.D0/(za(k5,k6))/(zb(k2,k3))/(zb(
     &    k5,k6))/(zab(k1,K2f,k1))/(zab(k1,K2f,k1))/(zab(k4,K1f,k4))/(
     &    zab(k4,K1f,k4))/(zab(k4,K2f,k4))/(zab(k4,K2f,k4))*zab(k1,K2f,
     &    k2)*zab(k1,K2f,k4)*zab(k4,K1f,k1)*zab(k4,K2f,k2)*zab(k4,K2f,
     &    k5)*zab(k6,K1f,k4)*zbab(k4,K1f,p3,k4)*a22 - 1.D0/2.D0/(za(k5,
     &    k6))/(zb(k2,k3))/(zb(k5,k6))/(zab(k1,K2f,k1))/(zab(k1,K2f,k1)
     &    )/(zab(k4,K1f,k4))/(zab(k4,K2f,k4))/(zab(k4,K2f,k4))*zb(k2,k4
     &    )*zab(k1,K2f,k4)**2*zab(k4,K1f,k1)*zab(k4,K2f,k2)*zab(k4,K2f,
     &    k5)*zab(k6,K1f,k4)*a22 - 1.D0/2.D0/(za(k5,k6))/(zb(k2,k3))/(
     &    zb(k5,k6))/(zab(k1,K2f,k1))/(zab(k4,K1f,k4))/(zab(k4,K1f,k4))
     &    /(zab(k4,K2f,k4))*zab(k1,K2f,k2)*zab(k4,K2f,k2)*zab(k4,K2f,k5
     &    )*zab(k6,K1f,k4)*zbab(k4,K1f,p3,k4)*a11 )
      coeff(3,c12x34) = coeff(3,c12x34) + bp * ( 1.D0/2.D0/(za(k5,k6))
     &    /(zb(k2,k3))/(zb(k5,k6))/(zab(k1,K2f,k1))/(zab(k4,K1f,k4))/(
     &    zab(k4,K1f,k4))/(zab(k4,K2f,k4))/(zab(k4,K2f,k4))*zab(k1,K2f,
     &    k4)*zab(k4,K1f,k2)*zab(k4,K2f,k2)*zab(k4,K2f,k5)*zab(k6,K1f,
     &    k4)*zbab(k4,K1f,p3,k4)*a22 + 1.D0/2.D0/(za(k5,k6))/(zb(k2,k3)
     &    )/(zb(k5,k6))/(zab(k1,K2f,k1))/(zab(k4,K1f,k4))/(zab(k4,K2f,
     &    k4))*zab(k1,K2f,k2)*zab(k4,K2f,k2)*zab(k6,K1f,k4)*zbab(k5,K1f
     &    ,p3,k4)*a12 + 1.D0/2.D0/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))/(
     &    zab(k1,K2f,k1))/(zab(k4,K1f,k4))/(zab(k4,K2f,k4))*zab(k1,K2f,
     &    k2)*zab(k4,K2f,k5)*zab(k6,K1f,k4)*zbab(k2,K1f,p3,k4)*a22 + 1.D
     &    0/2.D0/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))/(zab(k1,K2f,k1))/(
     &    zab(k4,K1f,k4))/(zab(k4,K2f,k4))*zab(k1,K2f,k2)*zab(k4,K2f,k5
     &    )*zab(k6,K1f,k4)*zbab(k2,K2f,p3,k4)*a11 + 1.D0/2.D0/(za(k5,k6
     &    ))/(zb(k2,k3))/(zb(k5,k6))/(zab(k1,K2f,k1))/(zab(k4,K1f,k4))
     &    /(zab(k4,K2f,k4))*zab(k1,K2f,k2)*zab(k4,K2f,k5)*zab(k6,K2f,k2
     &    )*zbab(k4,K1f,p3,k4)*a21 )
      coeff(3,c12x34) = coeff(3,c12x34) + bp * (  - 1.D0/2.D0/(za(k5,k6
     &    ))/(zb(k2,k3))/(zb(k5,k6))/(zab(k1,K2f,k1))/(zab(k4,K1f,k4))
     &    /(zab(k4,K2f,k4))/(zab(k4,K2f,k4))*zab(k1,K2f,k2)*zab(k4,K2f,
     &    k2)*zab(k4,K2f,k5)*zab(k6,K1f,k4)*zbab(k4,K1f,p3,k4)*a12 + 1.D
     &    0/2.D0/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))/(zab(k1,K2f,k1))/(
     &    zab(k4,K2f,k4))*zb(k2,k4)*zab(k1,K2f,k4)*zab(k4,K2f,k2)*zab(
     &    k6,K1f,k5)*a12 + 1.D0/2.D0/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6)
     &    )/(zab(k1,K2f,k1))/(zab(k4,K2f,k4))*zb(k2,k4)*zab(k1,K2f,k4)*
     &    zab(k4,K2f,k5)*zab(k6,K1f,k2)*a22 + 1.D0/2.D0/(za(k5,k6))/(
     &    zb(k2,k3))/(zb(k5,k6))/(zab(k1,K2f,k1))/(zab(k4,K2f,k4))*zb(
     &    k2,k4)*zab(k1,K2f,k4)*zab(k4,K2f,k5)*zab(k6,K2f,k2)*a21 + 1.D0
     &    /2.D0/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))/(zab(k1,K2f,k1))/(
     &    zab(k4,K2f,k4))/(zab(k4,K2f,k4))*zb(k2,k4)*zab(k1,K2f,k4)*
     &    zab(k4,K2f,k2)*zab(k4,K2f,k5)*zab(k6,K1f,k4)*a22 - 1.D0/2.D0
     &    /(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))/(zab(k1,K2f,k1))/(zab(k4
     &    ,K2f,k4))/(zab(k4,K2f,k4))*zb(k2,k4)*zab(k1,K2f,k4)*zab(k4,
     &    K2f,k2)*zab(k4,K2f,k5)*zab(k6,K1f,k4)*a12 )
      enddo

C--- additional normalization factor for Rodrigo
      coeff(3,c12x34)=coeff(3,c12x34)/bp

c--- this is the (2,3) triangle

      be=sqrt(1d0-4d0*bm*bp)
      a11=-bm/be
      a12=bp/be
      a21=a11-cone
      a22=a12-cone

      coeff(3,c2x3)= + s234**(-1)*s1234**(-1) * ( 1.D0/2.D0*za(k1,k6)*
     &    zb(k2,k4)*zaP234b(k3,k5) )
      coeff(3,c2x3) = coeff(3,c2x3) + s234**(-1)*bm*s1234**(-1) * (  - 
     &    1.D0/2.D0/(zb(k3,k4))*za(k1,k6)*zb(k2,k4)**2*zaP234b(k2,k5) )
      coeff(3,c2x3) = coeff(3,c2x3) + s234**(-1)*bp*bm*s1234**(-1) * ( 
     &     - 1.D0/2.D0*za(k1,k6)*zb(k2,k4)*zaP234b(k3,k5)*be**(-1) - 1.D
     &    0/2.D0/(za(k2,k4))*za(k1,k6)*za(k3,k4)*zb(k2,k4)*zaP234b(k2,
     &    k5)*be**(-1) + 1.D0/2.D0/(za(k2,k4))*za(k1,k6)*za(k3,k4)*zb(
     &    k3,k4)*zaP234b(k3,k5)*be**(-1) )
      coeff(3,c2x3) = coeff(3,c2x3) + s234**(-1)*bp**2*s1234**(-1) * ( 
     &     - 1.D0/2.D0/(za(k2,k4))/(za(k2,k4))*za(k1,k6)*za(k3,k4)**2*
     &    zb(k3,k4)*zaP234b(k2,k5)*be**(-1) )
      coeff(3,c2x3) = coeff(3,c2x3) + s234**(-1)*bp**2*bm*s1234**(-1)
     &  * ( 2*za(k1,k6)*zb(k2,k4)*zaP234b(k3,k5)*be**(-2) )
      coeff(3,c2x3) = coeff(3,c2x3) + s123**(-1)*s1234**(-1) * ( 1.D0/2.
     &    D0*za(k1,k3)*zb(k4,k5)*zaP123b(k6,k2) )
      coeff(3,c2x3) = coeff(3,c2x3) + bm*s123**(-1)*s1234**(-1) * (  - 
     &    1.D0/2.D0/(za(k1,k2))*za(k1,k3)**2*zb(k4,k5)*zaP123b(k6,k3) )
      coeff(3,c2x3) = coeff(3,c2x3) + bm*s1234**(-1) * ( 1.D0/2.D0/(za(
     &    k1,k2))*za(k1,k3)*za(k1,k6)*zb(k4,k5) - 1.D0/2.D0/(zb(k3,k4))
     &    *za(k1,k6)*zb(k2,k4)*zb(k4,k5) )
      coeff(3,c2x3) = coeff(3,c2x3) + bp*s1234**(-1) * (  - 1.D0/2.D0/(
     &    za(k2,k4))/(zb(k1,k3))*zaP123b(k6,k2)*zaP234b(k2,k5) + 1.D0/2.
     &    D0/(za(k2,k4))/(zb(k1,k3))*zaP123b(k6,k3)*zaP234b(k3,k5) )
      coeff(3,c2x3) = coeff(3,c2x3) + bp*bm*s123**(-1)*s1234**(-1) * ( 
     &     - 1.D0/2.D0*za(k1,k3)*zb(k4,k5)*zaP123b(k6,k2)*be**(-1) + 1.D
     &    0/2.D0/(zb(k1,k3))*za(k1,k2)*zb(k1,k2)*zb(k4,k5)*zaP123b(k6,
     &    k2)*be**(-1) - 1.D0/2.D0/(zb(k1,k3))*za(k1,k3)*zb(k1,k2)*zb(
     &    k4,k5)*zaP123b(k6,k3)*be**(-1) )
      coeff(3,c2x3) = coeff(3,c2x3) + bp**2*s123**(-1)*s1234**(-1) * ( 
     &     - 1.D0/2.D0/(zb(k1,k3))/(zb(k1,k3))*za(k1,k2)*zb(k1,k2)**2*
     &    zb(k4,k5)*zaP123b(k6,k3)*be**(-1) )
      coeff(3,c2x3) = coeff(3,c2x3) + bp**2*s1234**(-1) * (  - 1.D0/2.D0
     &    /(za(k2,k4))/(za(k2,k4))/(zb(k1,k3))*za(k2,k3)*zaP123b(k6,k3)
     &    *zaP234b(k4,k5)*be**(-1) + 1.D0/2.D0/(za(k2,k4))/(zb(k1,k3))
     &    /(zb(k1,k3))*zb(k2,k3)*zaP123b(k6,k1)*zaP234b(k2,k5)*be**(-1)
     &     )
      coeff(3,c2x3) = coeff(3,c2x3) + bp**2*bm*s123**(-1)*s1234**(-1)
     &  * ( 2*za(k1,k3)*zb(k4,k5)*zaP123b(k6,k2)*be**(-2) )

c--------------------------- BUBBLES ----------------------------------

c--- this is the (123) bubble

      p3DP=-p3(4)*p123(4)+p3(1)*p123(1)+p3(2)*p123(2)+p3(3)*p123(3)
      al1=(-p3DP+dsqrt(p3DP**2-msq*s123))/s123
      al2=(-p3DP-dsqrt(p3DP**2-msq*s123))/s123
      eta=k1
      etaDp3=mom(eta,4)*p3(4)-mom(eta,1)*p3(1)
     &-mom(eta,2)*p3(2)-mom(eta,3)*p3(3)
      etaDP=-mom(eta,4)*p123(4)+mom(eta,1)*p123(1)
     &+mom(eta,2)*p123(2)+mom(eta,3)*p123(3)
      kappa=4d0/s123*(s123*etaDp3**2+msq*etaDP**2-2d0*p3DP*etaDp3*etaDP)
      n1(:)=p3(:)-al1*p123(:)
      n2(:)=p3(:)-al2*p123(:)

      coeff(2,b123)= + s123**(-1) * ( 1.D0/2.D0/(za(k5,k6))/(zaP23b(k1,
     &    k1))/(zaP23b(k1,k1))/(zaP23b(k4,k1))*za(k1,k3)**2*zb(k2,k3)*
     &    zaP23b(k6,k1)**2 + 2/(za(k5,k6))/(zaP23b(k1,k1))/(zaP23b(k4,
     &    k1))*za(k1,k3)*zaP23b(k6,k1)*zaP123b(k6,k2) )
      coeff(2,b123) = coeff(2,b123) + s123 * ( 1/(za(k5,k6))/(zb(k2,k3)
     &    )/(zaP23b(k4,k1))/(zab(k4,n1,k1))/(zab(k4,n2,k1))/(zaba(k1,p3
     &    ,p123,k1))/(zabab(k1,n2,p123,n2,k1))*za(k4,k6)**2*zab(k1,n2,
     &    k2)*zbab(k2,p3,n2,k1)*kappa + 1/(za(k5,k6))/(zb(k2,k3))/(
     &    zaP23b(k4,k1))/(zab(k4,n1,k1))/(zaba(k1,p3,p123,k1))/(zbab(k1
     &    ,n1,n2,k1))/(zabab(k1,n1,p123,n1,k1))*za(k4,k6)*zab(k1,n1,k2)
     &    *zab(k6,n1,k1)*zbab(k2,p3,n1,k1)*kappa - 1/(za(k5,k6))/(zb(k2
     &    ,k3))/(zaP23b(k4,k1))/(zab(k4,n1,k1))/(zaba(k1,p3,p123,k1))/(
     &    zbab(k1,n1,n2,k1))/(zabab(k1,n2,p123,n2,k1))*za(k4,k6)*zab(k1
     &    ,n2,k2)*zab(k6,n1,k1)*zbab(k2,p3,n2,k1)*kappa - 1/(za(k5,k6))
     &    /(zb(k2,k3))/(zaP23b(k4,k1))/(zaba(k1,p3,p123,k1))/(zbab(k1,
     &    p23,n1,k1))/(zbab(k1,p23,n2,k1))/(zabab(k1,n2,p123,n2,k1))*
     &    zab(k1,n2,k2)*zbab(k2,p3,n2,k1)*zaP23b(k6,k1)**2*kappa - 1/(
     &    za(k5,k6))/(zb(k2,k3))/(zaP23b(k4,k1))/(zaba(k1,p3,p123,k1))
     &    /(zbab(k1,p23,n1,k1))/(zbab(k1,n1,n2,k1))/(zabab(k1,n1,p123,
     &    n1,k1))*zab(k1,n1,k2)*zab(k6,n1,k1)*zbab(k2,p3,n1,k1)*zaP23b(
     &    k6,k1)*kappa )
      coeff(2,b123) = coeff(2,b123) + s123 * ( 1/(za(k5,k6))/(zb(k2,k3)
     &    )/(zaP23b(k4,k1))/(zaba(k1,p3,p123,k1))/(zbab(k1,p23,n1,k1))
     &    /(zbab(k1,n1,n2,k1))/(zabab(k1,n2,p123,n2,k1))*zab(k1,n2,k2)*
     &    zab(k6,n1,k1)*zbab(k2,p3,n2,k1)*zaP23b(k6,k1)*kappa + 1/(za(
     &    k5,k6))/(zb(k2,k3))/(zaP23b(k4,k1))/(zaP123b(k4,k4))/(zab(k4,
     &    n1,k1))/(zab(k4,n2,k1))/(zaba(k1,p3,p123,k1))*za(k4,k6)**2*
     &    zb(k2,k4)*zaP3b(k4,k2)*kappa - 1.D0/2.D0/(za(k5,k6))/(zb(k2,
     &    k3))/(zaP23b(k4,k1))/(zaP123b(k4,k4))/(zaP123b(k4,k4))*za(k4,
     &    k6)**2*zb(k2,k4)**2 )
      coeff(2,b123) = coeff(2,b123) + 2/(za(k5,k6))/(zb(k2,k3))/(
     & zaP23b(k4,k1))/(zaP123b(k4,k4))*za(k4,k6)*zb(k2,k4)*zaP123b(k6,
     & k2) + 1/(za(k5,k6))/(zaP23b(k1,k1))/(zaP23b(k4,k1))/(zaba(k1,p3,
     &    p123,k1))/(zbab(k1,p23,n1,k1))/(zbab(k1,p23,n2,k1))*za(k1,k3)
     &    *zb(k1,k2)*zaP3b(k2,k2)*zaP23b(k6,k1)**2*kappa

c--- this is the (234) bubble

c--- note: in the following, p3 -> p2
      p3DP=-p2(4)*p234(4)+p2(1)*p234(1)+p2(2)*p234(2)+p2(3)*p234(3)
      a=s234
      b=2*p3DP
      c=msq
c      al1=(-p3DP+dsqrt(p3DP**2-msq*s234))/s234
c      al2=(-p3DP-dsqrt(p3DP**2-msq*s234))/s234
      call solvequadratic(a,b,c,al1,al2)
      eta=k4
      etaDp3=mom(eta,4)*p2(4)-mom(eta,1)*p2(1)
     &-mom(eta,2)*p2(2)-mom(eta,3)*p2(3)
      etaDP=-mom(eta,4)*p234(4)+mom(eta,1)*p234(1)
     &+mom(eta,2)*p234(2)+mom(eta,3)*p234(3)
      kappa=4d0/s234*(s234*etaDp3**2+msq*etaDP**2-2d0*p3DP*etaDp3*etaDP)
      n1(:)=p2(:)-al1*p234(:)
      n2(:)=p2(:)-al2*p234(:)

      coeff(2,b234)= + s234**(-1) * (  - 2/(zb(k5,k6))/(zaP23b(k4,k1))
     &    /(zaP23b(k4,k4))*zb(k2,k4)*zaP23b(k4,k5)*zaP234b(k3,k5) - 1.D0
     &    /2.D0/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k4))/(zaP23b(k4,
     &    k4))*za(k2,k3)*zb(k2,k4)**2*zaP23b(k4,k5)**2 )
      coeff(2,b234) = coeff(2,b234) + s234 * (  - 1/(za(k2,k3))/(zb(k5,
     &    k6))/(zaP23b(k4,k1))/(zab(k4,n1,k1))/(zab(k4,n2,k1))/(zbab(k4
     &    ,p2,p234,k4))/(zabab(k4,n2,p234,n2,k4))*zb(k1,k5)**2*zab(k3,
     &    n2,k4)*zaba(k3,p2,n2,k4)*kappa - 1/(za(k2,k3))/(zb(k5,k6))/(
     &    zaP23b(k4,k1))/(zab(k4,n1,k1))/(zaba(k4,n1,n2,k4))/(zbab(k4,
     &    p2,p234,k4))/(zabab(k4,n1,p234,n1,k4))*zb(k1,k5)*zab(k3,n1,k4
     &    )*zab(k4,n1,k5)*zaba(k3,p2,n1,k4)*kappa + 1/(za(k2,k3))/(zb(
     &    k5,k6))/(zaP23b(k4,k1))/(zab(k4,n1,k1))/(zaba(k4,n1,n2,k4))/(
     &    zbab(k4,p2,p234,k4))/(zabab(k4,n2,p234,n2,k4))*zb(k1,k5)*zab(
     &    k3,n2,k4)*zab(k4,n1,k5)*zaba(k3,p2,n2,k4)*kappa + 1/(za(k2,k3
     &    ))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaba(k4,p23,n1,k4))/(zaba(k4,
     &    p23,n2,k4))/(zbab(k4,p2,p234,k4))/(zabab(k4,n2,p234,n2,k4))*
     &    zab(k3,n2,k4)*zaba(k3,p2,n2,k4)*zaP23b(k4,k5)**2*kappa + 1/(
     &    za(k2,k3))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaba(k4,p23,n1,k4))/(
     &    zaba(k4,n1,n2,k4))/(zbab(k4,p2,p234,k4))/(zabab(k4,n1,p234,n1
     &    ,k4))*zab(k3,n1,k4)*zab(k4,n1,k5)*zaba(k3,p2,n1,k4)*zaP23b(k4
     &    ,k5)*kappa )
      coeff(2,b234) = coeff(2,b234) + s234 * (  - 1/(za(k2,k3))/(zb(k5,
     &    k6))/(zaP23b(k4,k1))/(zaba(k4,p23,n1,k4))/(zaba(k4,n1,n2,k4))
     &    /(zbab(k4,p2,p234,k4))/(zabab(k4,n2,p234,n2,k4))*zab(k3,n2,k4
     &    )*zab(k4,n1,k5)*zaba(k3,p2,n2,k4)*zaP23b(k4,k5)*kappa + 1/(
     &    za(k2,k3))/(zb(k5,k6))/(zaP234b(k1,k1))/(zaP23b(k4,k1))/(zab(
     &    k4,n1,k1))/(zab(k4,n2,k1))/(zbab(k4,p2,p234,k4))*za(k1,k3)*
     &    zb(k1,k5)**2*zaP2b(k3,k1)*kappa + 1.D0/2.D0/(za(k2,k3))/(zb(
     &    k5,k6))/(zaP234b(k1,k1))/(zaP234b(k1,k1))/(zaP23b(k4,k1))*za(
     &    k1,k3)**2*zb(k1,k5)**2 )
      coeff(2,b234) = coeff(2,b234) + 2/(za(k2,k3))/(zb(k5,k6))/(
     & zaP234b(k1,k1))/(zaP23b(k4,k1))*za(k1,k3)*zb(k1,k5)*zaP234b(k3,
     & k5) + 1/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k4))/(zaba(k4,p23
     &    ,n1,k4))/(zaba(k4,p23,n2,k4))/(zbab(k4,p2,p234,k4))*za(k3,k4)
     &    *zb(k2,k4)*zaP2b(k3,k3)*zaP23b(k4,k5)**2*kappa

c--- this is the (23) bubble

      coeff(2,b23)= + s234**(-1) * (  - 1/(za(k2,k3))/(za(k2,k4))/(za(
     &    k5,k6))/(zb(k2,k3))/(zb(k5,k6))*za(k1,k6)*za(k3,k4)**2*zb(k3,
     &    k4)*zb(k4,k5) + 2.D0/3.D0/(za(k2,k3))/(za(k5,k6))/(zb(k2,k3))
     &    /(zb(k5,k6))*za(k1,k6)*za(k3,k4)*zb(k2,k4)*zb(k4,k5) + 1.D0/2.
     &    D0/(za(k2,k3))/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))*za(k1,k6)*
     &    za(k3,k4)*zb(k2,k4)*zb(k4,k5)*be**(-2) - 1/(za(k2,k4))/(za(k2
     &    ,k4))/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))*za(k1,k6)*za(k3,k4)
     &    **2*zb(k3,k4)*zb(k3,k5) - 1.D0/2.D0/(za(k2,k4))/(za(k2,k4))/(
     &    za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))*za(k1,k6)*za(k3,k4)**2*zb(
     &    k3,k4)*zb(k3,k5)*be**(-1) - 1.D0/2.D0/(za(k2,k4))/(za(k2,k4))
     &    /(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k4))*za(k2,k3)*za(k3,
     &    k4)*zb(k3,k4)*zaP23b(k4,k5)**2 + 1.D0/2.D0/(za(k2,k4))/(za(k2
     &    ,k4))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k4))*za(k2,k3)*
     &    za(k3,k4)*zb(k3,k4)*zaP23b(k4,k5)**2*be**(-1) - 2/(za(k2,k4))
     &    /(za(k2,k4))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k4))*za(
     &    k3,k4)**2*zb(k3,k4)*zaP23b(k4,k5)*zaP234b(k2,k5) )
      coeff(2,b23) = coeff(2,b23) + s234**(-1) * ( 1.D0/2.D0/(za(k2,k4)
     &    )/(za(k2,k4))/(zb(k5,k6))/(zaP23b(k4,k1))/(zaP23b(k4,k4))/(
     &    zaP23b(k4,k4))*za(k2,k3)*za(k3,k4)**2*zb(k3,k4)**2*zaP23b(k4,
     &    k5)**2 - 1/(za(k2,k4))/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))*
     &    za(k1,k6)*za(k3,k4)*zb(k2,k5)*zb(k3,k4)*be**(-1) - 1.D0/2.D0
     &    /(za(k2,k4))/(za(k5,k6))/(zb(k5,k6))*za(k1,k6)*za(k3,k4)*zb(
     &    k4,k5)*be**(-1) - 2.D0/3.D0/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6
     &    ))*za(k1,k6)*zb(k2,k4)*zb(k2,k5) - 1.D0/2.D0/(za(k5,k6))/(zb(
     &    k2,k3))/(zb(k5,k6))*za(k1,k6)*zb(k2,k4)*zb(k2,k5)*be**(-2) - 
     &    1.D0/2.D0/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))*za(k1,k6)*zb(k2
     &    ,k4)*zb(k2,k5)*be**(-1) )
      coeff(2,b23) = coeff(2,b23) + s123**(-1) * ( 1/(za(k2,k3))/(za(k5
     &    ,k6))/(zb(k1,k3))/(zb(k1,k3))/(zb(k5,k6))*za(k1,k2)*zb(k1,k2)
     &    *zb(k4,k5)*zaP23b(k6,k1) + 1.D0/2.D0/(za(k2,k3))/(za(k5,k6))
     &    /(zb(k1,k3))/(zb(k1,k3))/(zb(k5,k6))*za(k1,k2)*zb(k1,k2)*zb(
     &    k4,k5)*zaP23b(k6,k1)*be**(-1) + 1/(za(k2,k3))/(za(k5,k6))/(
     &    zb(k1,k3))/(zb(k2,k3))/(zb(k5,k6))*za(k1,k2)*za(k1,k6)*zb(k1,
     &    k2)**2*zb(k4,k5) - 1/(za(k2,k3))/(za(k5,k6))/(zb(k1,k3))/(zb(
     &    k5,k6))*za(k1,k2)*za(k3,k6)*zb(k1,k2)*zb(k4,k5) + 1.D0/2.D0/(
     &    za(k2,k3))/(za(k5,k6))/(zb(k1,k3))/(zb(k5,k6))*za(k1,k3)*zb(
     &    k4,k5)*zaP23b(k6,k1)*be**(-1) - 2.D0/3.D0/(za(k2,k3))/(za(k5,
     &    k6))/(zb(k2,k3))/(zb(k5,k6))*za(k1,k3)*za(k1,k6)*zb(k1,k2)*
     &    zb(k4,k5) - 1.D0/2.D0/(za(k2,k3))/(za(k5,k6))/(zb(k2,k3))/(
     &    zb(k5,k6))*za(k1,k3)*za(k1,k6)*zb(k1,k2)*zb(k4,k5)*be**(-2)
     &     + 2.D0/3.D0/(za(k2,k3))/(za(k5,k6))/(zb(k5,k6))*za(k1,k3)*
     &    za(k3,k6)*zb(k4,k5) + 1.D0/2.D0/(za(k2,k3))/(za(k5,k6))/(zb(
     &    k5,k6))*za(k1,k3)*za(k3,k6)*zb(k4,k5)*be**(-2) )
      coeff(2,b23) = coeff(2,b23) + s123**(-1) * (  - 1.D0/2.D0/(za(k5,
     &    k6))/(zb(k1,k3))/(zb(k1,k3))/(zaP23b(k1,k1))/(zaP23b(k1,k1))
     &    /(zaP23b(k4,k1))*za(k1,k2)**2*zb(k1,k2)**2*zb(k2,k3)*zaP23b(
     &    k6,k1)**2 - 3.D0/2.D0/(za(k5,k6))/(zb(k1,k3))/(zb(k1,k3))/(
     &    zaP23b(k1,k1))/(zaP23b(k4,k1))*za(k1,k2)*zb(k1,k2)*zb(k2,k3)*
     &    zaP23b(k6,k1)**2 - 1.D0/2.D0/(za(k5,k6))/(zb(k1,k3))/(zb(k1,
     &    k3))/(zaP23b(k1,k1))/(zaP23b(k4,k1))*za(k1,k2)*zb(k1,k2)*zb(
     &    k2,k3)*zaP23b(k6,k1)**2*be**(-1) - 2/(za(k5,k6))/(zb(k1,k3))
     &    /(zaP23b(k1,k1))/(zaP23b(k4,k1))*za(k1,k2)*za(k1,k6)*zb(k1,k2
     &    )**2*zaP23b(k6,k1) + 2/(za(k5,k6))/(zb(k1,k3))/(zaP23b(k1,k1)
     &    )/(zaP23b(k4,k1))*za(k1,k2)*za(k3,k6)*zb(k1,k2)*zb(k2,k3)*
     &    zaP23b(k6,k1) )
      coeff(2,b23) = coeff(2,b23) - 1/(za(k2,k3))/(za(k2,k4))/(za(k5,k6
     & ))/(zb(k1,k3))/(zb(k5,k6))*za(k2,k6)*za(k3,k4)*zb(k4,k5) - 1/(
     &    za(k2,k3))/(za(k2,k4))/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))*
     &    za(k1,k6)*za(k3,k4)*zb(k4,k5) + 1/(za(k2,k3))/(za(k5,k6))/(
     &    zb(k1,k3))/(zb(k1,k3))/(zb(k5,k6))*zb(k4,k5)*zaP23b(k6,k1) + 
     &    1.D0/2.D0/(za(k2,k3))/(za(k5,k6))/(zb(k1,k3))/(zb(k1,k3))/(
     &    zb(k5,k6))*zb(k4,k5)*zaP23b(k6,k1)*be**(-1) + 1/(za(k2,k3))/(
     &    za(k5,k6))/(zb(k1,k3))/(zb(k2,k3))/(zb(k5,k6))*za(k1,k6)*zb(
     &    k1,k2)*zb(k4,k5) - 1/(za(k2,k3))/(za(k5,k6))/(zb(k1,k3))/(zb(
     &    k5,k6))*za(k3,k6)*zb(k4,k5) - 1/(za(k2,k4))/(za(k2,k4))/(za(
     &    k5,k6))/(zb(k1,k3))/(zb(k5,k6))*za(k2,k6)*za(k3,k4)*zb(k3,k5)
     &     - 1.D0/2.D0/(za(k2,k4))/(za(k2,k4))/(za(k5,k6))/(zb(k1,k3))
     &    /(zb(k5,k6))*za(k2,k6)*za(k3,k4)*zb(k3,k5)*be**(-1) - 1/(za(
     &    k2,k4))/(za(k2,k4))/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))*za(k1
     &    ,k6)*za(k3,k4)*zb(k3,k5) - 1.D0/2.D0/(za(k2,k4))/(za(k2,k4))
     &    /(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))*za(k1,k6)*za(k3,k4)*zb(
     &    k3,k5)*be**(-1)
      coeff(2,b23) = coeff(2,b23) + 1/(za(k2,k4))/(za(k5,k6))/(zb(k1,k3
     & ))/(zb(k1,k3))/(zb(k5,k6))*zb(k3,k5)*zaP23b(k6,k1) + 1.D0/2.D0/(
     &    za(k2,k4))/(za(k5,k6))/(zb(k1,k3))/(zb(k1,k3))/(zb(k5,k6))*
     &    zb(k3,k5)*zaP23b(k6,k1)*be**(-1) + 1/(za(k2,k4))/(za(k5,k6))
     &    /(zb(k1,k3))/(zb(k2,k3))/(zb(k5,k6))*za(k1,k6)*zb(k1,k2)*zb(
     &    k3,k5) - 1.D0/2.D0/(za(k2,k4))/(za(k5,k6))/(zb(k1,k3))/(zb(k5
     &    ,k6))*za(k2,k6)*zb(k2,k5)*be**(-1) - 1/(za(k2,k4))/(za(k5,k6)
     &    )/(zb(k1,k3))/(zb(k5,k6))*za(k3,k6)*zb(k3,k5) - 1.D0/2.D0/(
     &    za(k2,k4))/(za(k5,k6))/(zb(k2,k3))/(zb(k5,k6))*za(k1,k6)*zb(
     &    k2,k5)*be**(-1)

c--- this is the (1234) bubble

      K1DK2=0.5d0*(s12-s34-s1234)
      a=1._dp
      b=-2*K1DK2
      c=s1234*s34
c      gam=K1DK2+sqrt(K1DK2**2-dcmplx(s1234*s34))
      call solvequadratic(a,b,c,gam,tmp)
      kappa=1d0-s1234*s34/gam**2
        mom(k34f,:)=(p34(:)-s34/gam*p56(:))/kappa
        mom(k56f,:)=(p56(:)-s1234/gam*p34(:))/kappa

      call spinoru(8,mom,za,zb)

      coeff(2,b1234)=coeff(2,b1234) + s234**(-1) * (  - 3.D0/2.D0/(za(
     &    k2,k3))/(zb(k2,k3))/(zaP1234b(k1,k1))/(zaP1234b(k1,k1))*za(k1
     &    ,k6)**2*za(k3,k4)*zb(k1,k4)*zb(k2,k4)*zb(k5,k6) - 1/(za(k2,k3
     &    ))/(zb(k2,k3))/(zaP1234b(k1,k1))/(zaP1234b(k1,k1))*za(k1,k6)*
     &    za(k3,k4)*zb(k1,k5)*zb(k2,k4)*zaP1234b(k1,k4) + 3.D0/2.D0/(
     &    zb(k2,k3))/(zaP1234b(k1,k1))/(zaP1234b(k1,k1))*za(k1,k6)**2*
     &    zb(k1,k2)*zb(k2,k4)*zb(k5,k6) + 1/(zb(k2,k3))/(zaP1234b(k1,k1
     &    ))/(zaP1234b(k1,k1))*za(k1,k6)*zb(k1,k5)*zb(k2,k4)*zaP1234b(
     &    k1,k2) )
      coeff(2,b1234) = coeff(2,b1234) + s123**(-1) * ( 2/(za(k1,k4))/(
     &    za(k2,k3))/(zb(k2,k3))/(zaP1234b(k1,k4))*za(k1,k3)*za(k1,k6)*
     &    zb(k4,k5)*zaP1234b(k1,k2) - 2/(za(k1,k4))/(za(k2,k3))/(zb(k2,
     &    k3))/(zaP1234b(k4,k4))*za(k1,k3)*za(k4,k6)*zb(k4,k5)*
     &    zaP1234b(k1,k2) + 2/(za(k2,k3))/(zb(k2,k3))/(zaP1234b(k1,k4))
     &    *za(k1,k3)*za(k1,k6)*zb(k2,k4)*zb(k4,k5) + 2/(za(k2,k3))/(zb(
     &    k2,k3))/(zaP1234b(k1,k4))/(zaP1234b(k4,k4))*za(k1,k3)*za(k1,
     &    k4)*za(k5,k6)*zb(k2,k4)*zb(k4,k5)**2 - 1/(za(k2,k3))/(zb(k2,
     &    k3))/(zaP1234b(k4,k4))*za(k1,k3)*za(k4,k6)*zb(k2,k4)*zb(k4,k5
     &    ) + 1/(za(k2,k3))/(zb(k2,k3))/(zaP1234b(k4,k4))/(zaP1234b(k4,
     &    k4))*za(k1,k3)*za(k4,k6)*za(k5,k6)*zb(k2,k4)*zb(k4,k5)*zb(k5,
     &    k6) + 1.D0/2.D0/(za(k2,k3))/(zb(k2,k3))/(zaP1234b(k4,k4))/(
     &    zaP1234b(k4,k4))*za(k1,k3)*za(k5,k6)*zb(k4,k5)**2*zaP1234b(k4
     &    ,k2) )
      coeff(2,b1234) = coeff(2,b1234) + s123**(-1)*s1234 * (  - 2/(za(
     &    k2,k3))/(zb(k2,k3))/(zaP1234b(k1,k4))/(zaP1234b(k4,k4))/(
     &    zaP1234b(k4,k4))*za(k1,k3)*za(k1,k4)*za(k5,k6)*zb(k2,k4)*zb(
     &    k4,k5)**2 )
      coeff(2,b1234) = coeff(2,b1234) + s1234 * (  - 1/(zb(k2,k3))/(
     &    zaP1234b(k1,k1))/(zaP1234b(k4,k1))/(zaP1234b(k4,k4))/(zbab(k1
     &    ,p34,p1234,k1))*za(k4,k6)*zb(k1,k2)**2*zb(k1,k5)*zaP3b(k1,k4)
     &     )
      coeff(2,b1234) = coeff(2,b1234) + 1/(za(k1,k4))/(za(k1,k34f))/(
     & za(k5,k6))/(zb(k1,k34f))/(zb(k1,k56f))/(zb(k2,k3))/(zaP1234b(k1,
     & k4))*za(k1,k6)**2*zb(k1,k2)*zb(k2,k56f)*zaP3b(k1,k4)*kappa**(-1)
     &     - 1/(za(k1,k4))/(za(k1,k34f))/(za(k5,k6))/(zb(k1,k34f))/(zb(
     &    k1,k56f))/(zb(k2,k3))/(zaP1234b(k4,k4))*za(k1,k6)*za(k4,k6)*
     &    zb(k1,k2)*zb(k2,k56f)*zaP3b(k1,k4)*kappa**(-1) + 1/(za(k1,k4)
     &    )/(za(k1,k34f))/(za(k5,k6))/(zb(k1,k34f))/(zb(k2,k3))/(zb(
     &    k34f,k56f))/(zaP1234b(k1,k4))*za(k1,k6)**2*zb(k2,k34f)*zb(k2,
     &    k56f)*zaP3b(k1,k4)*kappa**(-1) - 1/(za(k1,k4))/(za(k1,k34f))
     &    /(za(k5,k6))/(zb(k1,k34f))/(zb(k2,k3))/(zb(k34f,k56f))/(
     &    zaP1234b(k4,k4))*za(k1,k6)*za(k4,k6)*zb(k2,k34f)*zb(k2,k56f)*
     &    zaP3b(k1,k4)*kappa**(-1) - 1/(za(k1,k4))/(za(k1,k56f))/(zb(k1
     &    ,k34f))/(zb(k2,k3))/(zb(k34f,k56f))/(zaP1234b(k1,k4))*za(k1,
     &    k6)**2*zb(k2,k34f)**2*zb(k5,k6)*zaP3b(k1,k4)*gam**(-1)*
     &    kappa**(-1) + 1/(za(k1,k4))/(za(k1,k56f))/(zb(k1,k34f))/(zb(
     &    k2,k3))/(zb(k34f,k56f))/(zaP1234b(k4,k4))*za(k1,k6)*za(k4,k6)
     &    *zb(k2,k34f)**2*zb(k5,k6)*zaP3b(k1,k4)*gam**(-1)*kappa**(-1)
      coeff(2,b1234) = coeff(2,b1234) - 2/(za(k1,k4))/(za(k2,k3))/(zb(
     & k2,k3))/(zaP1234b(k1,k1))/(zaP1234b(k1,k4))*za(k1,k3)*za(k1,k6)*
     & zb(k4,k5)*zaP1234b(k1,k2) - 2/(za(k1,k4))/(za(k2,k3))/(zb(k2,k3)
     &    )/(zaP1234b(k4,k1))/(zaP1234b(k4,k4))/(zaP1234b(k4,k4))*za(k3
     &    ,k4)*za(k4,k6)*zb(k4,k5)*zaP1234b(k1,k4)*zaP1234b(k4,k2) - 
     &    1/(za(k1,k4))/(zb(k2,k3))/(zaP1234b(k1,k1))/(zaP1234b(k1,k4))
     &    /(zbab(k1,p34,p1234,k1))*za(k1,k6)**2*zb(k1,k2)**2*zb(k5,k6)*
     &    zaP3b(k1,k4) + 1/(za(k1,k4))/(zb(k2,k3))/(zaP1234b(k1,k1))/(
     &    zaP1234b(k4,k4))/(zbab(k1,p34,p1234,k1))*za(k1,k6)*za(k4,k6)*
     &    zb(k1,k2)**2*zb(k5,k6)*zaP3b(k1,k4) - 1/(za(k1,k34f))/(za(k4,
     &    k34f))/(za(k5,k6))/(zb(k1,k34f))/(zb(k1,k56f))/(zb(k2,k3))/(
     &    zaP1234b(k1,k4))*za(k6,k34f)**2*zb(k1,k2)*zb(k2,k56f)*zaP3b(
     &    k1,k4)*zaP1234b(k1,k34f)*gam**(-1)*kappa**(-1) + 1/(za(k1,
     &    k34f))/(za(k4,k34f))/(za(k5,k6))/(zb(k1,k34f))/(zb(k1,k56f))
     &    /(zb(k2,k3))/(zaP1234b(k4,k4))*za(k4,k6)*za(k6,k34f)*zb(k1,k2
     &    )*zb(k2,k56f)*zaP3b(k1,k4)*kappa**(-1)
      coeff(2,b1234) = coeff(2,b1234) - 1/(za(k1,k34f))/(za(k4,k34f))/(
     & za(k5,k6))/(zb(k1,k34f))/(zb(k2,k3))/(zb(k34f,k56f))/(zaP1234b(
     & k1,k4))*za(k6,k34f)**2*zb(k2,k34f)*zb(k2,k56f)*zaP3b(k1,k4)*
     & zaP1234b(k1,k34f)*gam**(-1)*kappa**(-1) + 1/(za(k1,k34f))/(za(k4
     &    ,k34f))/(za(k5,k6))/(zb(k1,k34f))/(zb(k2,k3))/(zb(k34f,k56f))
     &    /(zaP1234b(k4,k4))*za(k4,k6)*za(k6,k34f)*zb(k2,k34f)*zb(k2,
     &    k56f)*zaP3b(k1,k4)*kappa**(-1) + 1/(za(k1,k34f))/(za(k5,k6))
     &    /(zb(k1,k34f))/(zb(k2,k3))*za(k1,k6)*za(k6,k34f)*zb(k2,k4)*
     &    zb(k2,k34f)*gam**(-1)*kappa**(-1) - 1/(za(k1,k34f))/(za(k5,k6
     &    ))/(zb(k1,k34f))/(zb(k2,k3))*za(k6,k34f)**2*zb(k2,k4)*zb(k2,
     &    k34f)*zaP1234b(k1,k34f)*gam**(-2)*kappa**(-1) - 1/(za(k1,k34f
     &    ))/(za(k5,k6))/(zb(k2,k3))/(zbab(k1,p34,p1234,k1))*za(k1,k6)*
     &    za(k6,k34f)*zb(k1,k2)*zb(k2,k4) + 1/(za(k1,k34f))/(za(k5,k6))
     &    /(zb(k2,k3))/(zbab(k1,p34,p1234,k1))*za(k6,k34f)**2*zb(k1,k2)
     &    *zb(k2,k4)*zaP1234b(k1,k34f)*gam**(-1) - 1/(za(k1,k56f))/(za(
     &    k4,k56f))/(za(k5,k6))/(zb(k1,k34f))/(zb(k2,k3))/(zb(k34f,k56f
     &    ))/(zaP1234b(k1,k4))*za(k6,k56f)**2*zb(k2,k34f)**2*zaP3b(k1,
     &    k4)*zaP1234b(k1,k56f)*gam**(-1)*kappa**(-1)
      coeff(2,b1234) = coeff(2,b1234) - 1/(za(k1,k56f))/(za(k4,k56f))/(
     & zb(k1,k34f))/(zb(k2,k3))/(zb(k34f,k56f))/(zaP1234b(k4,k4))*za(k4
     & ,k6)*za(k6,k56f)*zb(k2,k34f)**2*zb(k5,k6)*zaP3b(k1,k4)*gam**(-1)
     & *kappa**(-1) - 1/(za(k1,k56f))/(za(k5,k6))/(za(k5,k6))/(zb(k1,
     &    k34f))/(zb(k2,k3))/(zb(k5,k6))*za(k6,k56f)**2*zb(k2,k4)*zb(k2
     &    ,k34f)*zaP1234b(k1,k56f)*gam**(-1)*kappa**(-1) - 1/(za(k1,
     &    k56f))/(za(k5,k6))/(zb(k1,k34f))/(zb(k2,k3))*za(k1,k6)*za(k6,
     &    k56f)*zb(k2,k4)*zb(k2,k34f)*gam**(-1)*kappa**(-1) - 1.D0/2.D0
     &    /(za(k2,k3))/(zb(k1,k4))/(zb(k1,k4))/(zb(k2,k3))/(zb(k5,k6))
     &    /(zaP1234b(k1,k1))/(zaP1234b(k1,k1))/(zaP1234b(k4,k4))*zb(k1,
     &    k5)**2*zb(k2,k4)*zaP1234b(k1,k4)**2*zaP1234b(k3,k1) + 1.D0/2.D
     &    0/(za(k2,k3))/(zb(k1,k4))/(zb(k1,k4))/(zb(k2,k3))/(zb(k5,k6))
     &    /(zaP1234b(k4,k4))*zb(k2,k4)*zb(k4,k5)**2*zaP1234b(k3,k1) + 1.
     &    D0/2.D0/(za(k2,k3))/(zb(k1,k4))/(zb(k2,k3))/(zb(k5,k6))/(
     &    zaP1234b(k1,k1))/(zaP1234b(k1,k1))/(zaP1234b(k4,k1))/(
     &    zaP1234b(k4,k4))*zb(k1,k5)**2*zaP1234b(k1,k4)**2*zaP1234b(k3,
     &    k1)*zaP1234b(k4,k2)
      coeff(2,b1234) = coeff(2,b1234) - 1.D0/2.D0/(za(k2,k3))/(zb(k1,k4
     & ))/(zb(k2,k3))/(zb(k5,k6))/(zaP1234b(k4,k4))/(zaP1234b(k4,k4))*
     & zb(k4,k5)**2*zaP1234b(k3,k4)*zaP1234b(k4,k2) - 2/(za(k2,k3))/(
     &    zb(k1,k4))/(zb(k2,k3))/(zaP1234b(k1,k4))/(zaP1234b(k4,k4))*
     &    za(k1,k3)*za(k5,k6)*zb(k2,k4)*zb(k4,k5)**2 - 2/(za(k2,k3))/(
     &    zb(k1,k4))/(zb(k2,k3))/(zaP1234b(k4,k4))/(zaP1234b(k4,k4))*
     &    za(k3,k4)*za(k5,k6)*zb(k2,k4)*zb(k4,k5)**2 + 1/(za(k2,k3))/(
     &    zb(k1,k4))/(zb(k2,k3))/(zaP1234b(k4,k4))/(zaP1234b(k4,k4))*
     &    za(k4,k6)*zb(k2,k4)*zb(k4,k5)*zaP1234b(k3,k4) - 2/(za(k2,k3))
     &    /(zb(k2,k3))/(zaP1234b(k1,k1))/(zaP1234b(k1,k1))*za(k1,k3)*
     &    za(k1,k6)*zb(k1,k5)*zb(k2,k4) + 1/(za(k4,k34f))/(za(k5,k6))/(
     &    zb(k1,k34f))/(zb(k2,k3))/(zb(k4,k34f))/(zaP1234b(k1,k4))*za(
     &    k6,k34f)**2*zb(k2,k34f)**2*zbab(k4,p3,p1234,k4)*zaP1234b(k1,
     &    k34f)*gam**(-2)*kappa**(-1) - 1/(za(k4,k34f))/(za(k5,k6))/(
     &    zb(k1,k34f))/(zb(k2,k3))/(zb(k4,k34f))/(zaP1234b(k4,k4))*za(
     &    k4,k6)*za(k6,k34f)*zb(k2,k34f)**2*zbab(k4,p3,p1234,k4)*
     &    gam**(-1)*kappa**(-1)
      coeff(2,b1234) = coeff(2,b1234) + 1/(za(k4,k34f))/(za(k5,k6))/(
     & zb(k1,k56f))/(zb(k2,k3))/(zaP1234b(k1,k4))*za(k6,k34f)**2*zb(k2,
     & k4)*zb(k2,k56f)*zaP1234b(k1,k34f)*gam**(-1) - 1/(za(k4,k34f))/(
     &    za(k5,k6))/(zb(k1,k56f))/(zb(k2,k3))/(zaP1234b(k4,k4))*za(k4,
     &    k6)*za(k6,k34f)*zb(k2,k4)*zb(k2,k56f) - 1/(za(k4,k34f))/(za(
     &    k5,k6))/(zb(k2,k3))/(zb(k4,k34f))/(zaP1234b(k1,k4))/(zbab(k1,
     &    p34,p1234,k1))*za(k6,k34f)**2*zb(k1,k2)*zb(k2,k34f)*zbab(k4,
     &    p3,p1234,k4)*zaP1234b(k1,k34f)*gam**(-1) + 1/(za(k4,k34f))/(
     &    za(k5,k6))/(zb(k2,k3))/(zb(k4,k34f))/(zaP1234b(k4,k4))/(zbab(
     &    k1,p34,p1234,k1))*za(k4,k6)*za(k6,k34f)*zb(k1,k2)*zb(k2,k34f)
     &    *zbab(k4,p3,p1234,k4) + 1/(za(k4,k56f))/(za(k5,k6))/(za(k5,k6
     &    ))/(zb(k1,k34f))/(zb(k2,k3))/(zb(k4,k34f))/(zb(k5,k6))/(
     &    zaP1234b(k1,k4))*za(k6,k56f)**2*zb(k2,k34f)**2*zbab(k4,p3,
     &    p1234,k4)*zaP1234b(k1,k56f)*gam**(-1)*kappa**(-1) + 1/(za(k4,
     &    k56f))/(za(k5,k6))/(zb(k1,k34f))/(zb(k2,k3))/(zb(k4,k34f))/(
     &    zaP1234b(k4,k4))*za(k4,k6)*za(k6,k56f)*zb(k2,k34f)**2*zbab(k4
     &    ,p3,p1234,k4)*gam**(-1)*kappa**(-1)
      coeff(2,b1234) = coeff(2,b1234) - 1/(zb(k1,k4))/(zb(k2,k3))/(
     & zaP1234b(k1,k4))/(zaP1234b(k4,k4))/(zaP1234b(k4,k4))*za(k1,k4)*
     & za(k5,k6)*zb(k2,k4)**2*zb(k4,k5)**2 - 1/(zb(k1,k56f))/(zb(k2,k3)
     &    )/(zaP1234b(k4,k1))/(zaP1234b(k4,k4))*za(k4,k6)*zb(k1,k5)*zb(
     &    k2,k4)*zb(k2,k56f) + 1/(zb(k2,k3))/(zb(k4,k34f))/(zaP1234b(k4
     &    ,k1))/(zaP1234b(k4,k4))/(zbab(k1,p34,p1234,k1))*za(k4,k6)*zb(
     &    k1,k2)*zb(k1,k5)*zb(k2,k34f)*zbab(k4,p3,p1234,k4) - 1/(zb(k2,
     &    k3))/(zaP1234b(k1,k1))/(zbab(k1,p34,p1234,k1))*za(k1,k6)*zb(
     &    k1,k2)*zb(k1,k5)*zb(k2,k4) + 1/(zb(k2,k3))/(zaP1234b(k4,k1))
     &    /(zaP1234b(k4,k4))/(zaP1234b(k4,k4))*za(k4,k6)**2*zb(k2,k4)**
     &    2*zb(k5,k6)

c--- this is the (12) bubble

      p3Dp12=p1Dp3+p2Dp3
      p34Dp12=p1Dp3+p1Dp4+p2Dp3+p2Dp4

      coeff(2,b12)=czip
      a=s12
      b=-2*p3Dp12
      c=msq
c      kappa1=(p3Dp12-sqrt(p3Dp12**2-msq*s12))/s12
      call solvequadratic(a,b,c,kappa1,tmp)

      a=s12
      b=-2*p34Dp12
      c=s34
c      kappa2=(p34Dp12-sqrt(p34Dp12**2-s34*s12))/s12
      call solvequadratic(a,b,c,kappa2,tmp)

c--- this is really p3 made flat wrt p12
      mom(k56f,:)=p3(:)-kappa1*p12(:)
c--- this is p34 made flat wrt p12
      mom(k34f,:)=p34(:)-kappa2*p12(:)

      call spinoru(8,mom,za,zb)

      coeff(2,b12)=coeff(2,b12) + s123**(-1)*s1234**(-1) * (  - 1/(za(
     &    k1,k56f))/(zb(k2,k3))/(zaP12b(k56f,k1))/(zaP12b(k56f,k56f))*
     &    za(k6,k56f)*zb(k4,k5)*zaP12b(k1,k56f)*zaP12b(k56f,k2)*
     &    zaP123b(k56f,k2) - 1/(za(k1,k56f))/(zb(k2,k3))/(zaP12b(k56f,
     &    k1))/(zaP12b(k56f,k56f))/(zaP12b(k56f,k56f))*za(k6,k56f)*zb(
     &    k4,k5)*zaP12b(k1,k56f)*zaP12b(k56f,k2)**2*kappa1*s12 - 1/(za(
     &    k1,k56f))/(zb(k2,k3))/(zaP12b(k56f,k1))/(zaP12b(k56f,k56f))/(
     &    zaP12b(k56f,k56f))*za(k6,k56f)*zb(k4,k5)*zaP12b(k1,k56f)*
     &    zaP12b(k56f,k2)*zaP123b(k56f,k2)*s12 - 1/(za(k1,k56f))/(zb(k2
     &    ,k3))/(zaP12b(k56f,k1))/(zaP12b(k56f,k56f))/(zaP12b(k56f,k56f
     &    ))*za(k6,k56f)*zb(k4,k5)*zaP12b(k1,k56f)*zaP12b(k56f,k2)*
     &    zaP123b(k56f,k2)*kappa1*s12 + 1/(zb(k1,k56f))/(zb(k2,k3))/(
     &    zaP12b(k1,k1))/(zaP12b(k56f,k56f))*za(k1,k6)*zb(k1,k2)*zb(k2,
     &    k56f)*zb(k4,k5)*kappa1*s12**2 + 1/(zb(k1,k56f))/(zb(k2,k3))/(
     &    zaP12b(k1,k1))/(zaP12b(k56f,k56f))*za(k1,k6)*zb(k1,k2)*zb(k4,
     &    k5)*zbab(k2,p123,p12,k56f)*s12 )
      coeff(2,b12) = coeff(2,b12) + s123**(-1)*s1234**(-1) * ( 1/(zb(k1
     &    ,k56f))/(zb(k2,k3))/(zaP12b(k1,k1))/(zaP12b(k56f,k56f))*za(k1
     &    ,k6)*zb(k1,k2)*zb(k4,k5)*zbab(k2,p123,p12,k56f)*kappa1*s12 + 
     &    1/(zb(k1,k56f))/(zb(k2,k3))/(zaP12b(k1,k1))/(zaP12b(k56f,k56f
     &    ))*za(k1,k56f)*zb(k1,k2)*zb(k2,k56f)*zb(k4,k5)*zaP12b(k6,k56f
     &    )*s12 + 1/(zb(k1,k56f))/(zb(k2,k3))/(zaP12b(k56f,k1))/(
     &    zaP12b(k56f,k56f))*za(k6,k56f)*zb(k1,k2)*zb(k2,k56f)*zb(k4,k5
     &    )*kappa1*s12**2 + 1/(zb(k1,k56f))/(zb(k2,k3))/(zaP12b(k56f,k1
     &    ))/(zaP12b(k56f,k56f))*za(k6,k56f)*zb(k1,k2)*zb(k4,k5)*zbab(
     &    k2,p123,p12,k56f)*s12 + 1/(zb(k1,k56f))/(zb(k2,k3))/(zaP12b(
     &    k56f,k1))/(zaP12b(k56f,k56f))*za(k6,k56f)*zb(k1,k2)*zb(k4,k5)
     &    *zbab(k2,p123,p12,k56f)*kappa1*s12 - 1/(zb(k2,k3))/(zaP12b(
     &    k56f,k1))/(zaP12b(k56f,k56f))/(zaP12b(k56f,k56f))*za(k6,k56f)
     &    *zb(k2,k56f)*zb(k4,k5)*zaP12b(k56f,k2)*kappa1*s12**2 - 1/(zb(
     &    k2,k3))/(zaP12b(k56f,k1))/(zaP12b(k56f,k56f))/(zaP12b(k56f,
     &    k56f))*za(k6,k56f)*zb(k4,k5)*zbab(k2,p123,p12,k56f)*zaP12b(
     &    k56f,k2)*s12 )
      coeff(2,b12) = coeff(2,b12) + s123**(-1)*s1234**(-1) * (  - 1/(
     &    zb(k2,k3))/(zaP12b(k56f,k1))/(zaP12b(k56f,k56f))/(zaP12b(k56f
     &    ,k56f))*za(k6,k56f)*zb(k4,k5)*zbab(k2,p123,p12,k56f)*zaP12b(
     &    k56f,k2)*kappa1*s12 )
      coeff(2,b12) = coeff(2,b12) + s1234**(-1) * (  - 1/(za(k1,k34f))
     &    /(za(k1,k56f))/(zb(k2,k3))/(zaP12b(k34f,k1))/(zaP12b(k34f,
     &    k34f))/(zaP12b(k34f,k34f))/(zaP12b(k34f,k56f))*za(k1,k4)*za(
     &    k6,k34f)*zb(k2,k4)*zaP12b(k1,k34f)*zaP12b(k34f,k2)*zaP12b(
     &    k34f,k4)*zaP12b(k34f,k5) + 1/(za(k1,k34f))/(za(k1,k56f))/(zb(
     &    k2,k3))/(zaP12b(k34f,k1))/(zaP12b(k34f,k34f))/(zaP12b(k34f,
     &    k34f))/(zaP12b(k34f,k56f))*za(k1,k6)*zaP3b(k34f,k4)*zaP12b(k1
     &    ,k34f)*zaP12b(k34f,k2)**2*zaP12b(k34f,k5) - 1/(za(k1,k34f))/(
     &    zb(k1,k56f))/(zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k1,k1))/(
     &    zaP12b(k56f,k56f))*za(k1,k4)*za(k1,k6)*zb(k1,k2)*zb(k2,k4)*
     &    zb(k4,k56f)*zb(k5,k56f)*s12 - 1/(za(k1,k34f))/(zb(k1,k56f))/(
     &    zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k34f,k1))/(zaP12b(k56f,
     &    k56f))*za(k1,k4)*za(k6,k34f)*zb(k1,k2)*zb(k2,k4)*zb(k4,k56f)*
     &    zb(k5,k56f)*s12 - 1/(za(k1,k34f))/(zb(k1,k56f))/(zb(k2,k3))/(
     &    zb(k56f,k34f))/(zaP12b(k34f,k1))/(zaP12b(k56f,k56f))*za(k1,k6
     &    )*zb(k1,k2)*zb(k5,k56f)*zaP12b(k34f,k2)*zbP12aP3b(k56f,k4) )
      coeff(2,b12) = coeff(2,b12) + s1234**(-1) * ( 1/(za(k1,k34f))/(
     &    zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k34f,k1))/(zaP12b(k34f,
     &    k56f))/(zaP12b(k56f,k56f))*za(k1,k4)*za(k6,k34f)*zb(k2,k4)*
     &    zb(k4,k56f)*zb(k5,k56f)*zaP12b(k34f,k2)*s12 + 1/(za(k1,k34f))
     &    /(zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k34f,k1))/(zaP12b(k34f,
     &    k56f))/(zaP12b(k56f,k56f))*za(k1,k6)*zb(k5,k56f)*zaP12b(k34f,
     &    k2)**2*zbP12aP3b(k56f,k4) + 1/(za(k1,k56f))/(za(k56f,k34f))/(
     &    zb(k1,k34f))/(zb(k1,k56f))/(zb(k2,k3))/(zaP12b(k34f,k1))/(
     &    zaP12b(k34f,k34f))*za(k1,k34f)*za(k4,k56f)*za(k6,k34f)*zb(k1,
     &    k2)*zb(k1,k4)*zb(k2,k4)*zb(k5,k34f)*s12 - 1/(za(k1,k56f))/(
     &    za(k56f,k34f))/(zb(k1,k34f))/(zb(k1,k56f))/(zb(k2,k3))/(
     &    zaP12b(k34f,k1))/(zaP12b(k34f,k34f))*za(k1,k34f)*za(k6,k56f)*
     &    zb(k1,k2)*zb(k1,k5)*zbab(k4,p3,p12,k34f)*zaP12b(k34f,k2) - 
     &    1/(za(k1,k56f))/(za(k56f,k34f))/(zb(k1,k34f))/(zb(k1,k56f))/(
     &    zb(k2,k3))/(zaP12b(k34f,k34f))/(zaP12b(k56f,k1))*za(k1,k34f)*
     &    za(k4,k56f)*za(k6,k56f)*zb(k1,k2)*zb(k1,k4)*zb(k2,k4)*zb(k5,
     &    k34f)*s12 )
      coeff(2,b12) = coeff(2,b12) + s1234**(-1) * ( 1/(za(k1,k56f))/(
     &    za(k56f,k34f))/(zb(k1,k34f))/(zb(k1,k56f))/(zb(k2,k3))/(
     &    zaP12b(k34f,k34f))/(zaP12b(k56f,k1))*za(k1,k34f)*za(k6,k56f)*
     &    zb(k1,k2)*zb(k1,k5)*zbab(k4,p3,p12,k34f)*zaP12b(k56f,k2) + 
     &    1/(za(k1,k56f))/(za(k56f,k34f))/(zb(k1,k56f))/(zb(k2,k3))/(
     &    zb(k56f,k34f))/(zaP12b(k34f,k1))/(zaP12b(k34f,k34f))*za(k1,
     &    k34f)*za(k4,k56f)*za(k6,k34f)*zb(k1,k2)*zb(k2,k4)*zb(k4,k56f)
     &    *zb(k5,k34f)*s12 - 1/(za(k1,k56f))/(za(k56f,k34f))/(zb(k1,
     &    k56f))/(zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k34f,k1))/(zaP12b(
     &    k34f,k34f))*za(k1,k34f)*za(k6,k56f)*zb(k1,k2)*zb(k5,k56f)*
     &    zbab(k4,p3,p12,k34f)*zaP12b(k34f,k2) - 1/(za(k1,k56f))/(za(
     &    k56f,k34f))/(zb(k1,k56f))/(zb(k2,k3))/(zb(k56f,k34f))/(
     &    zaP12b(k34f,k34f))/(zaP12b(k56f,k1))*za(k1,k34f)*za(k4,k56f)*
     &    za(k6,k56f)*zb(k1,k2)*zb(k2,k4)*zb(k4,k56f)*zb(k5,k34f)*s12
     &     + 1/(za(k1,k56f))/(za(k56f,k34f))/(zb(k1,k56f))/(zb(k2,k3))
     &    /(zb(k56f,k34f))/(zaP12b(k34f,k34f))/(zaP12b(k56f,k1))*za(k1,
     &    k34f)*za(k6,k56f)*zb(k1,k2)*zb(k5,k56f)*zbab(k4,p3,p12,k34f)*
     &    zaP12b(k56f,k2) )
      coeff(2,b12) = coeff(2,b12) + s1234**(-1) * (  - 1/(za(k1,k56f))
     &    /(za(k56f,k34f))/(zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k34f,k1)
     &    )/(zaP12b(k34f,k34f))/(zaP12b(k34f,k56f))*za(k1,k34f)*za(k4,
     &    k56f)*za(k6,k34f)*zb(k2,k4)*zb(k4,k56f)*zb(k5,k34f)*zaP12b(
     &    k34f,k2)*s12 + 1/(za(k1,k56f))/(za(k56f,k34f))/(zb(k2,k3))/(
     &    zb(k56f,k34f))/(zaP12b(k34f,k1))/(zaP12b(k34f,k34f))/(zaP12b(
     &    k34f,k56f))*za(k1,k34f)*za(k6,k56f)*zb(k5,k56f)*zbab(k4,p3,
     &    p12,k34f)*zaP12b(k34f,k2)**2 + 1/(za(k1,k56f))/(za(k56f,k34f)
     &    )/(zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k34f,k34f))/(zaP12b(
     &    k56f,k1))/(zaP12b(k56f,k56f))*za(k1,k34f)*za(k4,k56f)*za(k6,
     &    k56f)*zb(k2,k4)*zb(k4,k56f)*zb(k5,k34f)*zaP12b(k56f,k2)*s12
     &     - 1/(za(k1,k56f))/(za(k56f,k34f))/(zb(k2,k3))/(zb(k56f,k34f)
     &    )/(zaP12b(k34f,k34f))/(zaP12b(k56f,k1))/(zaP12b(k56f,k56f))*
     &    za(k1,k34f)*za(k6,k56f)*zb(k5,k56f)*zbab(k4,p3,p12,k34f)*
     &    zaP12b(k56f,k2)**2 - 1/(za(k1,k56f))/(za(k56f,k34f))/(zb(k2,
     &    k3))/(zaP12b(k34f,k1))/(zaP12b(k34f,k34f))/(zaP12b(k34f,k34f)
     &    )/(zaP12b(k34f,k56f))*za(k1,k34f)*za(k4,k56f)*za(k6,k34f)*zb(
     &    k2,k4)*zb(k5,k34f)*zaP12b(k34f,k2)*zaP12b(k34f,k4)*s12 )
      coeff(2,b12) = coeff(2,b12) + s1234**(-1) * ( 1/(za(k1,k56f))/(
     &    za(k56f,k34f))/(zb(k2,k3))/(zaP12b(k34f,k1))/(zaP12b(k34f,
     &    k34f))/(zaP12b(k34f,k34f))/(zaP12b(k34f,k56f))*za(k1,k34f)*
     &    za(k6,k56f)*zbab(k4,p3,p12,k34f)*zaP12b(k34f,k2)**2*zaP12b(
     &    k34f,k5) - 1/(za(k1,k56f))/(za(k56f,k34f))/(zb(k2,k3))/(
     &    zaP12b(k34f,k1))/(zaP12b(k34f,k34f))/(zaP12b(k34f,k34f))/(
     &    zaP12b(k34f,k56f))*za(k4,k56f)*za(k6,k34f)*zb(k2,k4)*zaP12b(
     &    k1,k34f)*zaP12b(k34f,k2)*zaP12b(k34f,k4)*zaP12b(k34f,k5) + 
     &    1/(za(k1,k56f))/(za(k56f,k34f))/(zb(k2,k3))/(zaP12b(k34f,k1))
     &    /(zaP12b(k34f,k34f))/(zaP12b(k34f,k34f))/(zaP12b(k34f,k56f))*
     &    za(k6,k56f)*zaP3b(k34f,k4)*zaP12b(k1,k34f)*zaP12b(k34f,k2)**2
     &    *zaP12b(k34f,k5) + 1/(za(k1,k56f))/(za(k56f,k34f))/(zb(k2,k3)
     &    )/(zaP12b(k34f,k34f))/(zaP12b(k56f,k1))/(zaP12b(k56f,k34f))/(
     &    zaP12b(k56f,k56f))*za(k1,k34f)*za(k4,k56f)*za(k6,k56f)*zb(k2,
     &    k4)*zb(k5,k34f)*zaP12b(k56f,k2)*zaP12b(k56f,k4)*s12 - 1/(za(
     &    k1,k56f))/(za(k56f,k34f))/(zb(k2,k3))/(zaP12b(k34f,k34f))/(
     &    zaP12b(k56f,k1))/(zaP12b(k56f,k34f))/(zaP12b(k56f,k56f))*za(
     &    k1,k34f)*za(k6,k56f)*zbab(k4,p3,p12,k34f)*zaP12b(k56f,k2)**2*
     &    zaP12b(k56f,k5) )
      coeff(2,b12) = coeff(2,b12) + s1234**(-1) * ( 1/(za(k1,k56f))/(
     &    za(k56f,k34f))/(zb(k2,k3))/(zaP12b(k56f,k1))/(zaP12b(k56f,
     &    k34f))/(zaP12b(k56f,k56f))/(zaP12b(k56f,k56f))*za(k4,k56f)*
     &    za(k6,k56f)*zb(k2,k4)*zaP12b(k1,k56f)*zaP12b(k56f,k2)*zaP12b(
     &    k56f,k4)*zaP12b(k56f,k5) - 1/(za(k1,k56f))/(za(k56f,k34f))/(
     &    zb(k2,k3))/(zaP12b(k56f,k1))/(zaP12b(k56f,k34f))/(zaP12b(k56f
     &    ,k56f))/(zaP12b(k56f,k56f))*za(k6,k56f)*zaP3b(k56f,k4)*
     &    zaP12b(k1,k56f)*zaP12b(k56f,k2)**2*zaP12b(k56f,k5) + 1/(za(k1
     &    ,k56f))/(zb(k1,k34f))/(zb(k1,k56f))/(zb(k2,k3))/(zaP12b(k1,k1
     &    ))/(zaP12b(k34f,k34f))*za(k1,k4)*za(k1,k6)*zb(k1,k2)*zb(k1,k4
     &    )*zb(k2,k4)*zb(k5,k34f)*s12 + 1/(za(k1,k56f))/(zb(k1,k34f))/(
     &    zb(k1,k56f))/(zb(k2,k3))/(zaP12b(k34f,k1))/(zaP12b(k34f,k34f)
     &    )*za(k1,k4)*za(k6,k34f)*zb(k1,k2)*zb(k1,k4)*zb(k2,k4)*zb(k5,
     &    k34f)*s12 - 1/(za(k1,k56f))/(zb(k1,k34f))/(zb(k1,k56f))/(zb(
     &    k2,k3))/(zaP12b(k34f,k1))/(zaP12b(k34f,k34f))*za(k1,k6)*zb(k1
     &    ,k2)*zb(k1,k5)*zbab(k4,p3,p12,k34f)*zaP12b(k34f,k2) )
      coeff(2,b12) = coeff(2,b12) + s1234**(-1) * ( 1/(za(k1,k56f))/(
     &    zb(k1,k56f))/(zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k1,k1))/(
     &    zaP12b(k34f,k34f))*za(k1,k4)*za(k1,k6)*zb(k1,k2)*zb(k2,k4)*
     &    zb(k4,k56f)*zb(k5,k34f)*s12 + 1/(za(k1,k56f))/(zb(k1,k56f))/(
     &    zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k34f,k1))/(zaP12b(k34f,
     &    k34f))*za(k1,k4)*za(k6,k34f)*zb(k1,k2)*zb(k2,k4)*zb(k4,k56f)*
     &    zb(k5,k34f)*s12 - 1/(za(k1,k56f))/(zb(k1,k56f))/(zb(k2,k3))/(
     &    zb(k56f,k34f))/(zaP12b(k34f,k1))/(zaP12b(k34f,k34f))*za(k1,k6
     &    )*zb(k1,k2)*zb(k5,k56f)*zbab(k4,p3,p12,k34f)*zaP12b(k34f,k2)
     &     - 1/(za(k1,k56f))/(zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k34f,
     &    k1))/(zaP12b(k34f,k34f))/(zaP12b(k34f,k56f))*za(k1,k4)*za(k6,
     &    k34f)*zb(k2,k4)*zb(k4,k56f)*zb(k5,k34f)*zaP12b(k34f,k2)*s12
     &     + 1/(za(k1,k56f))/(zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k34f,
     &    k1))/(zaP12b(k34f,k34f))/(zaP12b(k34f,k56f))*za(k1,k6)*zb(k5,
     &    k56f)*zbab(k4,p3,p12,k34f)*zaP12b(k34f,k2)**2 - 1/(za(k1,k56f
     &    ))/(zb(k2,k3))/(zaP12b(k34f,k1))/(zaP12b(k34f,k34f))/(zaP12b(
     &    k34f,k34f))/(zaP12b(k34f,k56f))*za(k1,k4)*za(k6,k34f)*zb(k2,
     &    k4)*zb(k5,k34f)*zaP12b(k34f,k2)*zaP12b(k34f,k4)*s12 )
      coeff(2,b12) = coeff(2,b12) + s1234**(-1) * ( 1/(za(k1,k56f))/(
     &    zb(k2,k3))/(zaP12b(k34f,k1))/(zaP12b(k34f,k34f))/(zaP12b(k34f
     &    ,k34f))/(zaP12b(k34f,k56f))*za(k1,k6)*zbab(k4,p3,p12,k34f)*
     &    zaP12b(k34f,k2)**2*zaP12b(k34f,k5) + 1/(za(k1,k56f))/(zb(k2,
     &    k3))/(zaP12b(k56f,k1))/(zaP12b(k56f,k56f))/(zaP12b(k56f,k56f)
     &    )*za(k6,k56f)*zb(k2,k5)*zaP12b(k1,k56f)*zaP12b(k56f,k2)*
     &    zaP12b(k56f,k4) - 1/(za(k56f,k34f))/(zb(k1,k56f))/(zb(k2,k3))
     &    /(zb(k56f,k34f))/(zaP12b(k34f,k1))/(zaP12b(k56f,k56f))*za(k4,
     &    k56f)*za(k6,k34f)*zb(k1,k2)*zb(k2,k4)*zb(k4,k56f)*zb(k5,k56f)
     &    *s12 - 1/(za(k56f,k34f))/(zb(k1,k56f))/(zb(k2,k3))/(zb(k56f,
     &    k34f))/(zaP12b(k34f,k1))/(zaP12b(k56f,k56f))*za(k6,k56f)*zb(
     &    k1,k2)*zb(k5,k56f)*zaP12b(k34f,k2)*zbP12aP3b(k56f,k4) + 1/(
     &    za(k56f,k34f))/(zb(k1,k56f))/(zb(k2,k3))/(zb(k56f,k34f))/(
     &    zaP12b(k56f,k1))/(zaP12b(k56f,k56f))*za(k4,k56f)*za(k6,k56f)*
     &    zb(k1,k2)*zb(k2,k4)*zb(k4,k56f)*zb(k5,k56f)*s12 + 1/(za(k56f,
     &    k34f))/(zb(k1,k56f))/(zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k56f
     &    ,k1))/(zaP12b(k56f,k56f))*za(k6,k56f)*zb(k1,k2)*zb(k5,k56f)*
     &    zaP12b(k56f,k2)*zbP12aP3b(k56f,k4) )
      coeff(2,b12) = coeff(2,b12) + s1234**(-1) * ( 1/(za(k56f,k34f))/(
     &    zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k34f,k1))/(zaP12b(k34f,
     &    k56f))/(zaP12b(k56f,k56f))*za(k4,k56f)*za(k6,k34f)*zb(k2,k4)*
     &    zb(k4,k56f)*zb(k5,k56f)*zaP12b(k34f,k2)*s12 + 1/(za(k56f,k34f
     &    ))/(zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k34f,k1))/(zaP12b(k34f
     &    ,k56f))/(zaP12b(k56f,k56f))*za(k6,k56f)*zb(k5,k56f)*zaP12b(
     &    k34f,k2)**2*zbP12aP3b(k56f,k4) - 1/(za(k56f,k34f))/(zb(k2,k3)
     &    )/(zb(k56f,k34f))/(zaP12b(k56f,k1))/(zaP12b(k56f,k56f))/(
     &    zaP12b(k56f,k56f))*za(k4,k56f)*za(k6,k56f)*zb(k2,k4)*zb(k4,
     &    k56f)*zb(k5,k56f)*zaP12b(k56f,k2)*s12 - 1/(za(k56f,k34f))/(
     &    zb(k2,k3))/(zb(k56f,k34f))/(zaP12b(k56f,k1))/(zaP12b(k56f,
     &    k56f))/(zaP12b(k56f,k56f))*za(k6,k56f)*zb(k5,k56f)*zaP12b(
     &    k56f,k2)**2*zbP12aP3b(k56f,k4) - 1/(zb(k1,k56f))/(zb(k2,k3))
     &    /(zaP12b(k1,k1))/(zaP12b(k56f,k56f))*za(k1,k6)*zb(k1,k2)*zb(
     &    k2,k5)*zb(k4,k56f)*s12 - 1/(zb(k1,k56f))/(zb(k2,k3))/(zaP12b(
     &    k56f,k1))/(zaP12b(k56f,k56f))*za(k6,k56f)*zb(k1,k2)*zb(k2,k5)
     &    *zb(k4,k56f)*s12 )
      coeff(2,b12) = coeff(2,b12) + s1234**(-1) * ( 1/(zb(k2,k3))/(
     &    zaP12b(k56f,k1))/(zaP12b(k56f,k56f))/(zaP12b(k56f,k56f))*za(
     &    k6,k56f)*zb(k2,k5)*zb(k4,k56f)*zaP12b(k56f,k2)*s12 )
      coeff(2,b12) = coeff(2,b12) + bm*s123**(-1)*s1234**(-1) * (  - 
     &    1/(za(k1,k56f))/(zaP12b(k1,k1))*za(k1,k3)*za(k6,k56f)*zb(k4,
     &    k5)*zaP123b(k1,k2) + 1/(za(k1,k56f))/(zaP12b(k1,k1))/(zaP12b(
     &    k1,k56f))*za(k1,k3)*za(k1,k6)*zb(k4,k5)*zaP123b(k1,k2)*s12 + 
     &    1/(za(k1,k56f))/(zaP12b(k1,k1))/(zaP12b(k1,k56f))*za(k1,k3)*
     &    za(k1,k6)*zb(k4,k5)*zaP123b(k1,k2)*kappa1*s12 + 1/(zaP12b(k1,
     &    k1))/(zaP12b(k1,k56f))/(zaP12b(k56f,k56f))*za(k1,k3)*za(k1,k6
     &    )*zb(k2,k56f)*zb(k4,k5)*kappa1*s12**2 + 1/(zaP12b(k1,k1))/(
     &    zaP12b(k1,k56f))/(zaP12b(k56f,k56f))*za(k1,k3)*za(k1,k6)*zb(
     &    k4,k5)*zbab(k2,p123,p12,k56f)*s12 + 1/(zaP12b(k1,k1))/(
     &    zaP12b(k1,k56f))/(zaP12b(k56f,k56f))*za(k1,k3)*za(k1,k6)*zb(
     &    k4,k5)*zbab(k2,p123,p12,k56f)*kappa1*s12 + 1/(zaP12b(k1,k1))
     &    /(zaP12b(k1,k56f))/(zaP12b(k56f,k56f))*za(k1,k3)*za(k1,k56f)*
     &    zb(k2,k56f)*zb(k4,k5)*zaP12b(k6,k56f)*s12 )
      coeff(2,b12) = coeff(2,b12) + bm*s1234**(-1) * ( 1/(za(k1,k34f))
     &    /(za(k1,k56f))/(zaP12b(k1,k1))/(zaP12b(k1,k34f))/(zaP12b(k1,
     &    k56f))*za(k1,k3)*za(k1,k4)*za(k1,k6)*zb(k2,k4)*zaP12b(k1,k4)*
     &    zaP12b(k1,k5) - 1/(za(k1,k34f))/(zb(k1,k56f))/(zb(k56f,k34f))
     &    /(zaP12b(k1,k1))/(zaP12b(k56f,k56f))*za(k1,k3)*za(k1,k6)*zb(
     &    k1,k2)*zb(k5,k56f)*zbP12aP3b(k56f,k4) - 1/(za(k1,k34f))/(zb(
     &    k56f,k34f))/(zaP12b(k1,k1))/(zaP12b(k1,k56f))/(zaP12b(k56f,
     &    k56f))*za(k1,k3)*za(k1,k4)*za(k1,k6)*zb(k2,k4)*zb(k4,k56f)*
     &    zb(k5,k56f)*s12 - 1/(za(k1,k56f))/(zb(k1,k34f))/(zb(k1,k56f))
     &    /(zaP12b(k1,k1))/(zaP12b(k34f,k34f))*za(k1,k3)*za(k1,k6)*zb(
     &    k1,k2)*zb(k1,k5)*zbab(k4,p3,p12,k34f) - 1/(za(k1,k56f))/(zb(
     &    k1,k56f))/(zb(k56f,k34f))/(zaP12b(k1,k1))/(zaP12b(k34f,k34f))
     &    *za(k1,k3)*za(k1,k6)*zb(k1,k2)*zb(k5,k56f)*zbab(k4,p3,p12,
     &    k34f) + 1/(za(k1,k56f))/(zb(k56f,k34f))/(zaP12b(k1,k1))/(
     &    zaP12b(k1,k56f))/(zaP12b(k34f,k34f))*za(k1,k3)*za(k1,k4)*za(
     &    k1,k6)*zb(k2,k4)*zb(k4,k56f)*zb(k5,k34f)*s12 )
      coeff(2,b12) = coeff(2,b12) + bm*s1234**(-1) * ( 1/(za(k1,k56f))
     &    /(zaP12b(k1,k1))/(zaP12b(k1,k34f))/(zaP12b(k1,k56f))/(zaP12b(
     &    k34f,k34f))*za(k1,k3)*za(k1,k4)*za(k1,k6)*zb(k2,k4)*zb(k5,
     &    k34f)*zaP12b(k1,k4)*s12 - 1/(za(k1,k56f))/(zaP12b(k1,k1))/(
     &    zaP12b(k1,k56f))*za(k1,k3)*za(k1,k6)*zb(k2,k5)*zaP12b(k1,k4)
     &     - 1/(zaP12b(k1,k1))/(zaP12b(k1,k56f))/(zaP12b(k56f,k56f))*
     &    za(k1,k3)*za(k1,k6)*zb(k2,k5)*zb(k4,k56f)*s12 )
      coeff(2,b12) = coeff(2,b12) + bm**2*s123**(-1)*s1234**(-1) * ( 
     &     - 1/(za(k1,k56f))/(zaP12b(k1,k1))/(zaP12b(k1,k56f))*za(k1,k3
     &    )**2*za(k1,k6)*zb(k2,k3)*zb(k4,k5)*kappa1*s12 - 1/(zaP12b(k1,
     &    k1))/(zaP12b(k1,k56f))*za(k1,k3)**2*zb(k2,k3)*zb(k4,k5)*
     &    zaP12b(k6,k56f) )
      coeff(2,b12) = coeff(2,b12) + bm**2*s1234**(-1) * (  - 1/(za(k1,
     &    k34f))/(za(k1,k56f))/(zaP12b(k1,k1))/(zaP12b(k1,k34f))/(
     &    zaP12b(k1,k56f))*za(k1,k3)**2*za(k1,k6)*zb(k2,k3)*zaP3b(k1,k4
     &    )*zaP12b(k1,k5) - 1/(za(k1,k34f))/(zb(k56f,k34f))/(zaP12b(k1,
     &    k1))/(zaP12b(k1,k56f))/(zaP12b(k56f,k56f))*za(k1,k3)**2*za(k1
     &    ,k6)*zb(k2,k3)*zb(k5,k56f)*zbP12aP3b(k56f,k4) - 1/(za(k1,k56f
     &    ))/(zb(k56f,k34f))/(zaP12b(k1,k1))/(zaP12b(k1,k56f))/(zaP12b(
     &    k34f,k34f))*za(k1,k3)**2*za(k1,k6)*zb(k2,k3)*zb(k5,k56f)*
     &    zbab(k4,p3,p12,k34f) - 1/(za(k1,k56f))/(zaP12b(k1,k1))/(
     &    zaP12b(k1,k34f))/(zaP12b(k1,k56f))/(zaP12b(k34f,k34f))*za(k1,
     &    k3)**2*za(k1,k6)*zb(k2,k3)*zbab(k4,p3,p12,k34f)*zaP12b(k1,k5)
     &     )
      coeff(2,b12) = coeff(2,b12) + mb**2*s123**(-1)*s1234**(-1) * ( 
     &     - 1/(za(k1,k56f))/(zb(k2,k3))/(zaP12b(k56f,k1))/(zaP12b(k56f
     &    ,k56f))/(zaP12b(k56f,k56f))*za(k6,k56f)*zb(k4,k5)*zaP12b(k1,
     &    k56f)*zaP12b(k56f,k2)**2 + 1/(zb(k1,k56f))/(zb(k2,k3))/(
     &    zaP12b(k1,k1))/(zaP12b(k56f,k56f))*za(k1,k6)*zb(k1,k2)*zb(k2,
     &    k56f)*zb(k4,k5)*s12 + 1/(zb(k1,k56f))/(zb(k2,k3))/(zaP12b(
     &    k56f,k1))/(zaP12b(k56f,k56f))*za(k6,k56f)*zb(k1,k2)*zb(k2,
     &    k56f)*zb(k4,k5)*s12 - 1/(zb(k2,k3))/(zaP12b(k56f,k1))/(
     &    zaP12b(k56f,k56f))/(zaP12b(k56f,k56f))*za(k6,k56f)*zb(k2,k56f
     &    )*zb(k4,k5)*zaP12b(k56f,k2)*s12 )
      coeff(2,b12) = coeff(2,b12) + mb**2*bm*s123**(-1)*s1234**(-1)
     &  * ( 1/(zaP12b(k1,k1))/(zaP12b(k1,k56f))/(zaP12b(k56f,k56f))*za(
     &    k1,k3)*za(k1,k6)*zb(k2,k56f)*zb(k4,k5)*s12 )
      coeff(2,b12) = coeff(2,b12) + mb**2*bm**2*s123**(-1)*s1234**(-1)
     &  * (  - 1/(za(k1,k56f))/(zaP12b(k1,k1))/(zaP12b(k1,k56f))*za(k1,
     &    k3)**2*za(k1,k6)*zb(k2,k3)*zb(k4,k5) )

c--- this is the (34) bubble

c--- note: in the following, p3 <-> p2 and p1 <-> p4
      p3Dp12=p2Dp4+p2Dp3
      p34Dp12=p1Dp3+p1Dp4+p2Dp3+p2Dp4

      coeff(2,b34)=czip
      a=s34
      b=-2*p3Dp12
      c=msq
c      kappa1=(p3Dp12-sqrt(p3Dp12**2-msq*s34))/s34
      call solvequadratic(a,b,c,kappa1,tmp)

      a=s34
      b=-2*p34Dp12
      c=s12
c      kappa2=(p34Dp12-sqrt(p34Dp12**2-s34*s12))/s34
      call solvequadratic(a,b,c,kappa2,tmp)
c--- this is really p2 made flat wrt p34
      mom(k56f,:)=p2(:)-kappa1*p34(:)
c--- this is p12 made flat wrt p34
      mom(k34f,:)=p12(:)-kappa2*p34(:)

      call spinoru(8,mom,za,zb)

      coeff(2,b34)=coeff(2,b34) + s234**(-1)*s1234**(-1) * (  - 1/(za(
     &    k2,k3))/(za(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k56f,k56f))*za(
     &    k1,k6)*za(k3,k4)*za(k3,k56f)*zb(k4,k5)*kappa1*s34**2 - 1/(za(
     &    k2,k3))/(za(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k56f,k56f))*za(
     &    k1,k6)*za(k3,k4)*za(k3,k56f)*zb(k4,k56f)*zaP34b(k56f,k5)*s34
     &     - 1/(za(k2,k3))/(za(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k56f,
     &    k56f))*za(k1,k6)*za(k3,k4)*zb(k4,k5)*zaP234bP34a(k3,k56f)*s34
     &     - 1/(za(k2,k3))/(za(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k56f,
     &    k56f))*za(k1,k6)*za(k3,k4)*zb(k4,k5)*zaP234bP34a(k3,k56f)*
     &    kappa1*s34 - 1/(za(k2,k3))/(za(k4,k56f))/(zaP34b(k4,k56f))/(
     &    zaP34b(k56f,k56f))*za(k1,k6)*za(k3,k4)*za(k3,k56f)*zb(k5,k56f
     &    )*kappa1*s34**2 - 1/(za(k2,k3))/(za(k4,k56f))/(zaP34b(k4,k56f
     &    ))/(zaP34b(k56f,k56f))*za(k1,k6)*za(k3,k4)*zb(k5,k56f)*
     &    zaP234bP34a(k3,k56f)*s34 - 1/(za(k2,k3))/(za(k4,k56f))/(
     &    zaP34b(k4,k56f))/(zaP34b(k56f,k56f))*za(k1,k6)*za(k3,k4)*zb(
     &    k5,k56f)*zaP234bP34a(k3,k56f)*kappa1*s34 )
      coeff(2,b34) = coeff(2,b34) + s234**(-1)*s1234**(-1) * (  - 1/(
     &    za(k2,k3))/(zb(k4,k56f))/(zaP34b(k4,k56f))/(zaP34b(k56f,k56f)
     &    )*za(k1,k6)*zb(k5,k56f)*zaP34b(k3,k56f)*zaP34b(k56f,k4)*
     &    zaP234b(k3,k56f) - 1/(za(k2,k3))/(zb(k4,k56f))/(zaP34b(k4,
     &    k56f))/(zaP34b(k56f,k56f))/(zaP34b(k56f,k56f))*za(k1,k6)*zb(
     &    k5,k56f)*zaP34b(k3,k56f)**2*zaP34b(k56f,k4)*kappa1*s34 - 1/(
     &    za(k2,k3))/(zb(k4,k56f))/(zaP34b(k4,k56f))/(zaP34b(k56f,k56f)
     &    )/(zaP34b(k56f,k56f))*za(k1,k6)*zb(k5,k56f)*zaP34b(k3,k56f)*
     &    zaP34b(k56f,k4)*zaP234b(k3,k56f)*s34 - 1/(za(k2,k3))/(zb(k4,
     &    k56f))/(zaP34b(k4,k56f))/(zaP34b(k56f,k56f))/(zaP34b(k56f,
     &    k56f))*za(k1,k6)*zb(k5,k56f)*zaP34b(k3,k56f)*zaP34b(k56f,k4)*
     &    zaP234b(k3,k56f)*kappa1*s34 - 1/(za(k2,k3))/(zaP34b(k4,k56f))
     &    /(zaP34b(k56f,k56f))/(zaP34b(k56f,k56f))*za(k1,k6)*za(k3,k56f
     &    )*zb(k5,k56f)*zaP34b(k3,k56f)*kappa1*s34**2 - 1/(za(k2,k3))/(
     &    zaP34b(k4,k56f))/(zaP34b(k56f,k56f))/(zaP34b(k56f,k56f))*za(
     &    k1,k6)*zb(k5,k56f)*zaP34b(k3,k56f)*zaP234bP34a(k3,k56f)*s34 )
      coeff(2,b34) = coeff(2,b34) + s234**(-1)*s1234**(-1) * (  - 1/(
     &    za(k2,k3))/(zaP34b(k4,k56f))/(zaP34b(k56f,k56f))/(zaP34b(k56f
     &    ,k56f))*za(k1,k6)*zb(k5,k56f)*zaP34b(k3,k56f)*zaP234bP34a(k3,
     &    k56f)*kappa1*s34 )
      coeff(2,b34) = coeff(2,b34) + s234**(-1)*bm*s1234**(-1) * (  - 
     &    1/(zb(k4,k56f))/(zaP34b(k4,k4))*za(k1,k6)*zb(k2,k4)*zb(k5,
     &    k56f)*zaP234b(k3,k4) + 1/(zb(k4,k56f))/(zaP34b(k4,k4))/(
     &    zaP34b(k56f,k4))*za(k1,k6)*zb(k2,k4)*zb(k4,k5)*zaP234b(k3,k4)
     &    *s34 + 1/(zb(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k56f,k4))*za(
     &    k1,k6)*zb(k2,k4)*zb(k4,k5)*zaP234b(k3,k4)*kappa1*s34 + 1/(
     &    zaP34b(k4,k4))/(zaP34b(k56f,k4))/(zaP34b(k56f,k56f))*za(k1,k6
     &    )*za(k3,k56f)*zb(k2,k4)*zb(k4,k5)*kappa1*s34**2 + 1/(zaP34b(
     &    k4,k4))/(zaP34b(k56f,k4))/(zaP34b(k56f,k56f))*za(k1,k6)*za(k3
     &    ,k56f)*zb(k2,k4)*zb(k4,k56f)*zaP34b(k56f,k5)*s34 + 1/(zaP34b(
     &    k4,k4))/(zaP34b(k56f,k4))/(zaP34b(k56f,k56f))*za(k1,k6)*zb(k2
     &    ,k4)*zb(k4,k5)*zaP234bP34a(k3,k56f)*s34 + 1/(zaP34b(k4,k4))/(
     &    zaP34b(k56f,k4))/(zaP34b(k56f,k56f))*za(k1,k6)*zb(k2,k4)*zb(
     &    k4,k5)*zaP234bP34a(k3,k56f)*kappa1*s34 )
      coeff(2,b34) = coeff(2,b34) + s234**(-1)*bm**2*s1234**(-1) * ( 
     &     - 1/(zb(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k56f,k4))*za(k1,k6
     &    )*za(k2,k3)*zb(k2,k4)**2*zb(k4,k5)*kappa1*s34 - 1/(zaP34b(k4,
     &    k4))/(zaP34b(k56f,k4))*za(k1,k6)*za(k2,k3)*zb(k2,k4)**2*
     &    zaP34b(k56f,k5) )
      coeff(2,b34) = coeff(2,b34) + s1234**(-1) * (  - 1/(za(k2,k3))/(
     &    za(k4,k34f))/(za(k4,k56f))/(zb(k4,k56f))/(zb(k56f,k34f))/(
     &    zaP34b(k4,k34f))/(zaP34b(k34f,k34f))*za(k1,k3)*za(k1,k4)*za(
     &    k3,k4)*za(k6,k34f)*zb(k1,k56f)*zb(k4,k34f)*zb(k5,k34f)*s34 + 
     &    1/(za(k2,k3))/(za(k4,k34f))/(za(k4,k56f))/(zb(k4,k56f))/(zb(
     &    k56f,k34f))/(zaP34b(k4,k34f))/(zaP34b(k34f,k34f))*za(k3,k4)*
     &    za(k4,k6)*zb(k4,k34f)*zb(k5,k56f)*zaP34b(k3,k34f)*zaP2bP34a(
     &    k1,k34f) + 1/(za(k2,k3))/(za(k4,k34f))/(za(k4,k56f))/(zb(k4,
     &    k56f))/(zb(k56f,k34f))/(zaP34b(k4,k56f))/(zaP34b(k34f,k34f))*
     &    za(k1,k3)*za(k1,k4)*za(k3,k4)*za(k6,k34f)*zb(k1,k56f)*zb(k4,
     &    k34f)*zb(k5,k56f)*s34 - 1/(za(k2,k3))/(za(k4,k34f))/(za(k4,
     &    k56f))/(zb(k4,k56f))/(zb(k56f,k34f))/(zaP34b(k4,k56f))/(
     &    zaP34b(k34f,k34f))*za(k3,k4)*za(k4,k6)*zb(k4,k34f)*zb(k5,k56f
     &    )*zaP34b(k3,k56f)*zaP2bP34a(k1,k34f) + 1/(za(k2,k3))/(za(k4,
     &    k34f))/(za(k4,k56f))/(zb(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(
     &    k34f,k34f))*za(k1,k3)*za(k1,k4)*za(k3,k4)*za(k6,k34f)*zb(k1,
     &    k4)*zb(k4,k5)*s34 )
      coeff(2,b34) = coeff(2,b34) + s1234**(-1) * ( 1/(za(k2,k3))/(za(
     &    k4,k34f))/(za(k4,k56f))/(zb(k4,k56f))/(zaP34b(k4,k34f))/(
     &    zaP34b(k34f,k34f))*za(k1,k3)*za(k1,k4)*za(k3,k4)*za(k6,k34f)*
     &    zb(k1,k4)*zb(k5,k34f)*s34 + 1/(za(k2,k3))/(za(k4,k34f))/(za(
     &    k4,k56f))/(zb(k4,k56f))/(zaP34b(k4,k34f))/(zaP34b(k34f,k34f))
     &    *za(k3,k4)*za(k4,k6)*zb(k4,k5)*zaP34b(k3,k34f)*zaP2bP34a(k1,
     &    k34f) + 1/(za(k2,k3))/(za(k4,k56f))/(za(k56f,k34f))/(zb(k4,
     &    k34f))/(zaP34b(k4,k4))/(zaP34b(k56f,k56f))*za(k1,k3)*za(k1,
     &    k56f)*za(k3,k4)*za(k6,k56f)*zb(k1,k4)*zb(k4,k5)*s34 + 1/(za(
     &    k2,k3))/(za(k4,k56f))/(za(k56f,k34f))/(zb(k4,k34f))/(zaP34b(
     &    k4,k34f))/(zaP34b(k56f,k56f))*za(k1,k3)*za(k1,k56f)*za(k3,k4)
     &    *za(k6,k56f)*zb(k1,k4)*zb(k5,k34f)*s34 + 1/(za(k2,k3))/(za(k4
     &    ,k56f))/(za(k56f,k34f))/(zb(k4,k34f))/(zaP34b(k4,k34f))/(
     &    zaP34b(k56f,k56f))*za(k3,k4)*za(k6,k56f)*zb(k4,k5)*zaP34b(k3,
     &    k34f)*zaP34bP2a(k56f,k1) + 1/(za(k2,k3))/(za(k4,k56f))/(za(
     &    k56f,k34f))/(zb(k4,k56f))/(zb(k56f,k34f))/(zaP34b(k4,k34f))/(
     &    zaP34b(k34f,k34f))*za(k1,k3)*za(k1,k56f)*za(k3,k4)*za(k6,k34f
     &    )*zb(k1,k56f)*zb(k4,k34f)*zb(k5,k34f)*s34 )
      coeff(2,b34) = coeff(2,b34) + s1234**(-1) * ( 1/(za(k2,k3))/(za(
     &    k4,k56f))/(za(k56f,k34f))/(zb(k4,k56f))/(zb(k56f,k34f))/(
     &    zaP34b(k4,k34f))/(zaP34b(k34f,k34f))*za(k3,k4)*za(k6,k56f)*
     &    zb(k4,k34f)*zb(k5,k56f)*zaP34b(k3,k34f)*zaP2bP34a(k1,k34f) - 
     &    1/(za(k2,k3))/(za(k4,k56f))/(za(k56f,k34f))/(zb(k4,k56f))/(
     &    zb(k56f,k34f))/(zaP34b(k4,k56f))/(zaP34b(k34f,k34f))*za(k1,k3
     &    )*za(k1,k56f)*za(k3,k4)*za(k6,k34f)*zb(k1,k56f)*zb(k4,k34f)*
     &    zb(k5,k56f)*s34 - 1/(za(k2,k3))/(za(k4,k56f))/(za(k56f,k34f))
     &    /(zb(k4,k56f))/(zb(k56f,k34f))/(zaP34b(k4,k56f))/(zaP34b(k34f
     &    ,k34f))*za(k3,k4)*za(k6,k56f)*zb(k4,k34f)*zb(k5,k56f)*zaP34b(
     &    k3,k56f)*zaP2bP34a(k1,k34f) - 1/(za(k2,k3))/(za(k4,k56f))/(
     &    za(k56f,k34f))/(zb(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k34f,
     &    k34f))*za(k1,k3)*za(k1,k56f)*za(k3,k4)*za(k6,k34f)*zb(k1,k4)*
     &    zb(k4,k5)*s34 - 1/(za(k2,k3))/(za(k4,k56f))/(za(k56f,k34f))/(
     &    zb(k4,k56f))/(zaP34b(k4,k34f))/(zaP34b(k34f,k34f))*za(k1,k3)*
     &    za(k1,k56f)*za(k3,k4)*za(k6,k34f)*zb(k1,k4)*zb(k5,k34f)*s34 )
      coeff(2,b34) = coeff(2,b34) + s1234**(-1) * ( 1/(za(k2,k3))/(za(
     &    k4,k56f))/(za(k56f,k34f))/(zb(k4,k56f))/(zaP34b(k4,k34f))/(
     &    zaP34b(k34f,k34f))*za(k3,k4)*za(k6,k56f)*zb(k4,k5)*zaP34b(k3,
     &    k34f)*zaP2bP34a(k1,k34f) - 1/(za(k2,k3))/(za(k4,k56f))/(za(
     &    k56f,k34f))/(zb(k56f,k34f))/(zaP34b(k4,k34f))/(zaP34b(k56f,
     &    k56f))*za(k1,k3)*za(k1,k56f)*za(k3,k4)*za(k6,k56f)*zb(k1,k56f
     &    )*zb(k5,k34f)*s34 + 1/(za(k2,k3))/(za(k4,k56f))/(za(k56f,k34f
     &    ))/(zb(k56f,k34f))/(zaP34b(k4,k34f))/(zaP34b(k56f,k56f))*za(
     &    k3,k4)*za(k6,k56f)*zb(k5,k56f)*zaP34b(k3,k34f)*zaP34bP2a(k56f
     &    ,k1) + 1/(za(k2,k3))/(za(k4,k56f))/(za(k56f,k34f))/(zb(k56f,
     &    k34f))/(zaP34b(k4,k56f))/(zaP34b(k56f,k56f))*za(k1,k3)*za(k1,
     &    k56f)*za(k3,k4)*za(k6,k56f)*zb(k1,k56f)*zb(k5,k56f)*s34 - 1/(
     &    za(k2,k3))/(za(k4,k56f))/(za(k56f,k34f))/(zb(k56f,k34f))/(
     &    zaP34b(k4,k56f))/(zaP34b(k56f,k56f))*za(k3,k4)*za(k6,k56f)*
     &    zb(k5,k56f)*zaP34b(k3,k56f)*zaP34bP2a(k56f,k1) + 1/(za(k2,k3)
     &    )/(za(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k56f,k56f))*za(k1,
     &    k56f)*za(k3,k4)*za(k3,k6)*zb(k4,k5)*s34 )
      coeff(2,b34) = coeff(2,b34) + s1234**(-1) * ( 1/(za(k2,k3))/(za(
     &    k4,k56f))/(zaP34b(k4,k56f))/(zaP34b(k56f,k56f))*za(k1,k56f)*
     &    za(k3,k4)*za(k3,k6)*zb(k5,k56f)*s34 + 1/(za(k2,k3))/(za(k56f,
     &    k34f))/(zb(k4,k34f))/(zaP34b(k4,k34f))/(zaP34b(k56f,k34f))/(
     &    zaP34b(k56f,k56f))*za(k1,k3)*za(k1,k56f)*za(k6,k56f)*zb(k1,k4
     &    )*zb(k5,k34f)*zaP34b(k3,k34f)*s34 + 1/(za(k2,k3))/(za(k56f,
     &    k34f))/(zb(k4,k34f))/(zaP34b(k4,k34f))/(zaP34b(k56f,k34f))/(
     &    zaP34b(k56f,k56f))*za(k6,k56f)*zb(k4,k5)*zaP34b(k3,k34f)**2*
     &    zaP34bP2a(k56f,k1) + 1/(za(k2,k3))/(za(k56f,k34f))/(zb(k4,
     &    k56f))/(zb(k56f,k34f))/(zaP34b(k4,k34f))/(zaP34b(k34f,k34f))
     &    /(zaP34b(k56f,k34f))*za(k1,k3)*za(k1,k56f)*za(k6,k34f)*zb(k1,
     &    k56f)*zb(k4,k34f)*zb(k5,k34f)*zaP34b(k3,k34f)*s34 + 1/(za(k2,
     &    k3))/(za(k56f,k34f))/(zb(k4,k56f))/(zb(k56f,k34f))/(zaP34b(k4
     &    ,k34f))/(zaP34b(k34f,k34f))/(zaP34b(k56f,k34f))*za(k6,k56f)*
     &    zb(k4,k34f)*zb(k5,k56f)*zaP34b(k3,k34f)**2*zaP2bP34a(k1,k34f)
     &     - 1/(za(k2,k3))/(za(k56f,k34f))/(zb(k4,k56f))/(zb(k56f,k34f)
     &    )/(zaP34b(k4,k56f))/(zaP34b(k34f,k34f))/(zaP34b(k56f,k56f))*
     &    za(k1,k3)*za(k1,k56f)*za(k6,k34f)*zb(k1,k56f)*zb(k4,k34f)*zb(
     &    k5,k56f)*zaP34b(k3,k56f)*s34 )
      coeff(2,b34) = coeff(2,b34) + s1234**(-1) * (  - 1/(za(k2,k3))/(
     &    za(k56f,k34f))/(zb(k4,k56f))/(zb(k56f,k34f))/(zaP34b(k4,k56f)
     &    )/(zaP34b(k34f,k34f))/(zaP34b(k56f,k56f))*za(k6,k56f)*zb(k4,
     &    k34f)*zb(k5,k56f)*zaP34b(k3,k56f)**2*zaP2bP34a(k1,k34f) - 1/(
     &    za(k2,k3))/(za(k56f,k34f))/(zb(k4,k56f))/(zaP34b(k4,k34f))/(
     &    zaP34b(k34f,k34f))/(zaP34b(k56f,k34f))*za(k1,k3)*za(k1,k56f)*
     &    za(k6,k34f)*zb(k1,k4)*zb(k5,k34f)*zaP34b(k3,k34f)*s34 + 1/(
     &    za(k2,k3))/(za(k56f,k34f))/(zb(k4,k56f))/(zaP34b(k4,k34f))/(
     &    zaP34b(k34f,k34f))/(zaP34b(k56f,k34f))*za(k6,k56f)*zb(k4,k5)*
     &    zaP34b(k3,k34f)**2*zaP2bP34a(k1,k34f) - 1/(za(k2,k3))/(za(
     &    k56f,k34f))/(zb(k56f,k34f))/(zaP34b(k4,k34f))/(zaP34b(k56f,
     &    k34f))/(zaP34b(k56f,k56f))*za(k1,k3)*za(k1,k56f)*za(k6,k56f)*
     &    zb(k1,k56f)*zb(k5,k34f)*zaP34b(k3,k34f)*s34 + 1/(za(k2,k3))/(
     &    za(k56f,k34f))/(zb(k56f,k34f))/(zaP34b(k4,k34f))/(zaP34b(k56f
     &    ,k34f))/(zaP34b(k56f,k56f))*za(k6,k56f)*zb(k5,k56f)*zaP34b(k3
     &    ,k34f)**2*zaP34bP2a(k56f,k1) )
      coeff(2,b34) = coeff(2,b34) + s1234**(-1) * ( 1/(za(k2,k3))/(za(
     &    k56f,k34f))/(zb(k56f,k34f))/(zaP34b(k4,k56f))/(zaP34b(k56f,
     &    k56f))/(zaP34b(k56f,k56f))*za(k1,k3)*za(k1,k56f)*za(k6,k56f)*
     &    zb(k1,k56f)*zb(k5,k56f)*zaP34b(k3,k56f)*s34 - 1/(za(k2,k3))/(
     &    za(k56f,k34f))/(zb(k56f,k34f))/(zaP34b(k4,k56f))/(zaP34b(k56f
     &    ,k56f))/(zaP34b(k56f,k56f))*za(k6,k56f)*zb(k5,k56f)*zaP34b(k3
     &    ,k56f)**2*zaP34bP2a(k56f,k1) - 1/(za(k2,k3))/(zb(k4,k34f))/(
     &    zb(k4,k56f))/(zaP34b(k4,k34f))/(zaP34b(k34f,k34f))/(zaP34b(
     &    k34f,k34f))/(zaP34b(k56f,k34f))*za(k1,k3)*zb(k1,k4)*zb(k5,
     &    k34f)*zaP34b(k1,k34f)*zaP34b(k3,k34f)*zaP34b(k6,k34f)*zaP34b(
     &    k34f,k4) + 1/(za(k2,k3))/(zb(k4,k34f))/(zb(k4,k56f))/(zaP34b(
     &    k4,k34f))/(zaP34b(k34f,k34f))/(zaP34b(k34f,k34f))/(zaP34b(
     &    k56f,k34f))*zb(k4,k5)*zaP2b(k1,k34f)*zaP34b(k3,k34f)**2*
     &    zaP34b(k6,k34f)*zaP34b(k34f,k4) + 1/(za(k2,k3))/(zb(k4,k56f))
     &    /(zb(k56f,k34f))/(zaP34b(k4,k34f))/(zaP34b(k34f,k34f))/(
     &    zaP34b(k34f,k34f))/(zaP34b(k56f,k34f))*za(k1,k3)*za(k6,k34f)*
     &    zb(k1,k56f)*zb(k4,k34f)*zb(k5,k34f)*zaP34b(k1,k34f)*zaP34b(k3
     &    ,k34f)*s34 )
      coeff(2,b34) = coeff(2,b34) + s1234**(-1) * ( 1/(za(k2,k3))/(zb(
     &    k4,k56f))/(zb(k56f,k34f))/(zaP34b(k4,k34f))/(zaP34b(k34f,k34f
     &    ))/(zaP34b(k34f,k34f))/(zaP34b(k56f,k34f))*za(k1,k3)*zb(k1,
     &    k56f)*zb(k5,k34f)*zaP34b(k1,k34f)*zaP34b(k3,k34f)*zaP34b(k6,
     &    k34f)*zaP34b(k34f,k4) + 1/(za(k2,k3))/(zb(k4,k56f))/(zb(k56f,
     &    k34f))/(zaP34b(k4,k34f))/(zaP34b(k34f,k34f))/(zaP34b(k34f,
     &    k34f))/(zaP34b(k56f,k34f))*zb(k4,k34f)*zb(k5,k56f)*zaP34b(k3,
     &    k34f)**2*zaP34b(k6,k34f)*zaP2bP34a(k1,k34f) + 1/(za(k2,k3))/(
     &    zb(k4,k56f))/(zb(k56f,k34f))/(zaP34b(k4,k34f))/(zaP34b(k34f,
     &    k34f))/(zaP34b(k34f,k34f))/(zaP34b(k56f,k34f))*zb(k5,k56f)*
     &    zaP2b(k1,k34f)*zaP34b(k3,k34f)**2*zaP34b(k6,k34f)*zaP34b(k34f
     &    ,k4) - 1/(za(k2,k3))/(zb(k4,k56f))/(zb(k56f,k34f))/(zaP34b(k4
     &    ,k56f))/(zaP34b(k34f,k34f))/(zaP34b(k34f,k56f))/(zaP34b(k56f,
     &    k56f))*za(k1,k3)*za(k6,k34f)*zb(k1,k56f)*zb(k4,k34f)*zb(k5,
     &    k56f)*zaP34b(k1,k56f)*zaP34b(k3,k56f)*s34 - 1/(za(k2,k3))/(
     &    zb(k4,k56f))/(zb(k56f,k34f))/(zaP34b(k4,k56f))/(zaP34b(k34f,
     &    k34f))/(zaP34b(k34f,k56f))/(zaP34b(k56f,k56f))*zb(k4,k34f)*
     &    zb(k5,k56f)*zaP34b(k3,k56f)**2*zaP34b(k6,k56f)*zaP2bP34a(k1,
     &    k34f) )
      coeff(2,b34) = coeff(2,b34) + s1234**(-1) * (  - 1/(za(k2,k3))/(
     &    zb(k4,k56f))/(zb(k56f,k34f))/(zaP34b(k4,k56f))/(zaP34b(k34f,
     &    k56f))/(zaP34b(k56f,k56f))/(zaP34b(k56f,k56f))*za(k1,k3)*zb(
     &    k1,k56f)*zb(k5,k56f)*zaP34b(k1,k56f)*zaP34b(k3,k56f)*zaP34b(
     &    k6,k56f)*zaP34b(k56f,k4) - 1/(za(k2,k3))/(zb(k4,k56f))/(zb(
     &    k56f,k34f))/(zaP34b(k4,k56f))/(zaP34b(k34f,k56f))/(zaP34b(
     &    k56f,k56f))/(zaP34b(k56f,k56f))*zb(k5,k56f)*zaP2b(k1,k56f)*
     &    zaP34b(k3,k56f)**2*zaP34b(k6,k56f)*zaP34b(k56f,k4) - 1/(za(k2
     &    ,k3))/(zb(k4,k56f))/(zaP34b(k4,k34f))/(zaP34b(k34f,k34f))/(
     &    zaP34b(k34f,k34f))/(zaP34b(k56f,k34f))*za(k1,k3)*za(k6,k34f)*
     &    zb(k1,k4)*zb(k5,k34f)*zaP34b(k1,k34f)*zaP34b(k3,k34f)*s34 + 
     &    1/(za(k2,k3))/(zb(k4,k56f))/(zaP34b(k4,k34f))/(zaP34b(k34f,
     &    k34f))/(zaP34b(k34f,k34f))/(zaP34b(k56f,k34f))*zb(k4,k5)*
     &    zaP34b(k3,k34f)**2*zaP34b(k6,k34f)*zaP2bP34a(k1,k34f) + 1/(
     &    za(k2,k3))/(zb(k4,k56f))/(zaP34b(k4,k56f))/(zaP34b(k56f,k56f)
     &    )/(zaP34b(k56f,k56f))*za(k3,k6)*zb(k5,k56f)*zaP34b(k1,k56f)*
     &    zaP34b(k3,k56f)*zaP34b(k56f,k4) )
      coeff(2,b34) = coeff(2,b34) + s1234**(-1) * ( 1/(za(k2,k3))/(
     &    zaP34b(k4,k56f))/(zaP34b(k56f,k56f))/(zaP34b(k56f,k56f))*za(
     &    k1,k56f)*za(k3,k6)*zb(k5,k56f)*zaP34b(k3,k56f)*s34 )
      coeff(2,b34) = coeff(2,b34) + bm*s1234**(-1) * ( 1/(za(k4,k34f))
     &    /(za(k4,k56f))/(zb(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k34f,
     &    k34f))*za(k3,k4)*za(k4,k6)*zb(k2,k4)*zb(k4,k5)*zaP2bP34a(k1,
     &    k34f) + 1/(za(k4,k56f))/(za(k56f,k34f))/(zb(k4,k34f))/(
     &    zaP34b(k4,k4))/(zaP34b(k56f,k56f))*za(k3,k4)*za(k6,k56f)*zb(
     &    k2,k4)*zb(k4,k5)*zaP34bP2a(k56f,k1) + 1/(za(k4,k56f))/(za(
     &    k56f,k34f))/(zb(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k34f,k34f))
     &    *za(k3,k4)*za(k6,k56f)*zb(k2,k4)*zb(k4,k5)*zaP2bP34a(k1,k34f)
     &     - 1/(za(k56f,k34f))/(zb(k4,k34f))/(zaP34b(k4,k4))/(zaP34b(
     &    k56f,k4))/(zaP34b(k56f,k56f))*za(k1,k3)*za(k1,k56f)*za(k6,
     &    k56f)*zb(k1,k4)*zb(k2,k4)*zb(k4,k5)*s34 + 1/(za(k56f,k34f))/(
     &    zb(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k34f,k34f))/(zaP34b(k56f
     &    ,k4))*za(k1,k3)*za(k1,k56f)*za(k6,k34f)*zb(k1,k4)*zb(k2,k4)*
     &    zb(k4,k5)*s34 + 1/(zb(k4,k34f))/(zb(k4,k56f))/(zaP34b(k4,k4))
     &    /(zaP34b(k34f,k4))/(zaP34b(k56f,k4))*za(k1,k3)*zb(k1,k4)*zb(
     &    k2,k4)*zb(k4,k5)*zaP34b(k1,k4)*zaP34b(k6,k4) )
      coeff(2,b34) = coeff(2,b34) + bm*s1234**(-1) * ( 1/(zb(k4,k56f))
     &    /(zaP34b(k4,k4))/(zaP34b(k34f,k4))/(zaP34b(k34f,k34f))/(
     &    zaP34b(k56f,k4))*za(k1,k3)*za(k6,k34f)*zb(k1,k4)*zb(k2,k4)*
     &    zb(k4,k5)*zaP34b(k1,k4)*s34 - 1/(zb(k4,k56f))/(zaP34b(k4,k4))
     &    /(zaP34b(k56f,k4))*za(k3,k6)*zb(k2,k4)*zb(k4,k5)*zaP34b(k1,k4
     &    ) - 1/(zaP34b(k4,k4))/(zaP34b(k56f,k4))/(zaP34b(k56f,k56f))*
     &    za(k1,k56f)*za(k3,k6)*zb(k2,k4)*zb(k4,k5)*s34 )
      coeff(2,b34) = coeff(2,b34) + bm**2*s1234**(-1) * (  - 1/(za(k56f
     &    ,k34f))/(zb(k4,k34f))/(zaP34b(k4,k4))/(zaP34b(k56f,k4))/(
     &    zaP34b(k56f,k56f))*za(k2,k3)*za(k6,k56f)*zb(k2,k4)**2*zb(k4,
     &    k5)*zaP34bP2a(k56f,k1) - 1/(za(k56f,k34f))/(zb(k4,k56f))/(
     &    zaP34b(k4,k4))/(zaP34b(k34f,k34f))/(zaP34b(k56f,k4))*za(k2,k3
     &    )*za(k6,k56f)*zb(k2,k4)**2*zb(k4,k5)*zaP2bP34a(k1,k34f) - 1/(
     &    zb(k4,k34f))/(zb(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k34f,k4))
     &    /(zaP34b(k56f,k4))*za(k2,k3)*zb(k2,k4)**2*zb(k4,k5)*zaP2b(k1,
     &    k4)*zaP34b(k6,k4) - 1/(zb(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(
     &    k34f,k4))/(zaP34b(k34f,k34f))/(zaP34b(k56f,k4))*za(k2,k3)*zb(
     &    k2,k4)**2*zb(k4,k5)*zaP34b(k6,k4)*zaP2bP34a(k1,k34f) )
      coeff(2,b34) = coeff(2,b34) + mb**2*s234**(-1)*s1234**(-1) * ( 
     &     - 1/(za(k2,k3))/(za(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k56f,
     &    k56f))*za(k1,k6)*za(k3,k4)*za(k3,k56f)*zb(k4,k5)*s34 - 1/(za(
     &    k2,k3))/(za(k4,k56f))/(zaP34b(k4,k56f))/(zaP34b(k56f,k56f))*
     &    za(k1,k6)*za(k3,k4)*za(k3,k56f)*zb(k5,k56f)*s34 - 1/(za(k2,k3
     &    ))/(zb(k4,k56f))/(zaP34b(k4,k56f))/(zaP34b(k56f,k56f))/(
     &    zaP34b(k56f,k56f))*za(k1,k6)*zb(k5,k56f)*zaP34b(k3,k56f)**2*
     &    zaP34b(k56f,k4) - 1/(za(k2,k3))/(zaP34b(k4,k56f))/(zaP34b(
     &    k56f,k56f))/(zaP34b(k56f,k56f))*za(k1,k6)*za(k3,k56f)*zb(k5,
     &    k56f)*zaP34b(k3,k56f)*s34 )
      coeff(2,b34) = coeff(2,b34) + mb**2*s234**(-1)*bm*s1234**(-1)
     &  * ( 1/(zaP34b(k4,k4))/(zaP34b(k56f,k4))/(zaP34b(k56f,k56f))*za(
     &    k1,k6)*za(k3,k56f)*zb(k2,k4)*zb(k4,k5)*s34 )
      coeff(2,b34) = coeff(2,b34) + mb**2*s234**(-1)*bm**2*s1234**(-1)
     &  * (  - 1/(zb(k4,k56f))/(zaP34b(k4,k4))/(zaP34b(k56f,k4))*za(k1,
     &    k6)*za(k2,k3)*zb(k2,k4)**2*zb(k4,k5) )

c--------------------------- TADPOLE ----------------------------------

c--- No tadpole for this amplitude

c--- determine missing bubble (massive self energy) from pole structure
      coeff(2,b2x1m)=8d0/3d0*ampLO-msq*coeff(1,a0m)
     & -coeff(2,b123)-coeff(2,b234)-coeff(2,b23)
     & -coeff(2,b1234)-coeff(2,b12)-coeff(2,b34)

c---------------------------- RATIONAL TERMS --------------------------

      coeff(0,irat)= + s234**(-1)*s1234**(-1) * ( 1.D0/2.D0/(zb(k2,k3))
     &    *za(k1,k6)*zb(k2,k4)*zb(k2,k5) - 1.D0/2.D0/(zaP23b(k4,k4))*
     &    za(k1,k6)*za(k3,k4)*zb(k2,k4)*zb(k4,k5) )
      coeff(0,irat) = coeff(0,irat) + s123**(-1)*s1234**(-1) * (  - 1.D0
     &    /2.D0/(za(k2,k3))*za(k1,k3)*za(k3,k6)*zb(k4,k5) + 1.D0/2.D0/(
     &    zaP23b(k1,k1))*za(k1,k3)*za(k1,k6)*zb(k1,k2)*zb(k4,k5) )
      coeff(0,irat) = coeff(0,irat) + s1234**(-1) * (  - 1.D0/2.D0/(za(
     &    k2,k3))/(zb(k2,k3))/(zaP123b(k4,k4))*za(k1,k3)*za(k4,k6)*zb(
     &    k2,k4)*zb(k4,k5) + 1.D0/2.D0/(za(k2,k3))/(zb(k2,k3))/(
     &    zaP234b(k1,k1))*za(k1,k3)*za(k1,k6)*zb(k1,k5)*zb(k2,k4) + 1.D0
     &    /2.D0/(zaP23b(k1,k1))/(zaP23b(k4,k1))*za(k1,k3)*za(k1,k6)*zb(
     &    k1,k2)*zb(k1,k5) - 1.D0/2.D0/(zaP23b(k4,k1))/(zaP23b(k4,k4))*
     &    za(k3,k4)*za(k4,k6)*zb(k2,k4)*zb(k4,k5) )
      coeff(0,irat) = coeff(0,irat) + s123*s1234**(-1) * (  - 1.D0/2.D0
     &    /(za(k2,k3))/(zb(k2,k3))/(zaP23b(k4,k1))/(zaP123b(k4,k4))*za(
     &    k3,k4)*za(k4,k6)*zb(k2,k4)*zb(k4,k5) )
      coeff(0,irat) = coeff(0,irat) + s234*s1234**(-1) * ( 1.D0/2.D0/(
     &    za(k2,k3))/(zb(k2,k3))/(zaP234b(k1,k1))/(zaP23b(k4,k1))*za(k1
     &    ,k3)*za(k1,k6)*zb(k1,k2)*zb(k1,k5) )
      coeff(0,irat) = coeff(0,irat) - 2.D0/9.D0*amplo


c-- ADDITIONAL CONVERSION FOR BOXES AND TRIANGLES: 6-D TO 4-D BASIS ---
      coeff(4,d2x3x4)=coeff(4,d2x3x4)*za(k2,k3)*zb(k3,k2)*zab(k4,p3,k4)
      coeff(4,d1x2x3)=coeff(4,d1x2x3)*za(k2,k3)*zb(k3,k2)*zab(k1,p2,k1)
      coeff(4,d1x23x4)=coeff(4,d1x23x4)*zab(k4,p23,k1)*zab(k1,p23,k4)
      coeff(4,d1x2x34)=coeff(4,d1x2x34)*s234*zab(k1,p2,k1)
      coeff(4,d12x3x4)=coeff(4,d12x3x4)*s123*zab(k4,p3,k4)

      coeff(3,c23x4)=coeff(3,c23x4)*(-zab(k4,p23,k4))
      coeff(3,c1x23)=coeff(3,c1x23)*(-zab(k1,p23,k1))
      coeff(3,c3x4)=coeff(3,c3x4)*(zab(k4,p3,k4))
      coeff(3,c1x2)=coeff(3,c1x2)*(zab(k1,p2,k1))
      coeff(3,c1x234)=coeff(3,c1x234)*(-zab(k1,p234,k1))
      coeff(3,c123x4)=coeff(3,c123x4)*(-zab(k4,p123,k4))

      return
      end

