!
!  SPDX-License-Identifier: GPL-3.0-or-later
!  Copyright (C) 2019-2022, respective authors of MCFM.
!
      function Wpamp_Lmp(p1,p2,p3,p4,p5,p6,za,zb)
c     arXiv:2105.00954, Eq.(C.13)
      implicit none
      include 'types.f'
      include 'mxpart.f'
      include 'zprods_decl.f'
      include 'sprods_com.f'
      integer p1,p2,p3,p4,p5,p6
      complex(dp):: Wpamp_Lmp,zab,zab2,L0,L1,Lnrat
      real(dp):: t,delta2,Delta3,DeltaTM1526

c Statement functions
      t(p1,p2,p3)=s(p1,p2)+s(p2,p3)+s(p3,p1)
      zab(p1,p2,p3)=za(p1,p2)*zb(p2,p3)
      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)
      delta2(p1,p2,p3,p4,p5,p6)=s(p1,p2)-s(p3,p4)-s(p5,p6)
      Delta3(p1,p2,p3,p4,p5,p6)=
     & (s(p1,p2)**2+s(p3,p4)**2+s(p5,p6)**2
     & -2._dp*(s(p1,p2)*s(p3,p4)+s(p1,p2)*s(p5,p6)+s(p3,p4)*s(p5,p6)))

      DeltaTM1526=Delta3(p1,p5,p2,p6,p3,p4)

      Wpamp_Lmp=
     & s(p3,p4)*(
     & +1._dp/(DeltaTM1526)*(zab2(p2,p1,p5,p6)*zab2(p5,p2,p6,p1)*zab2(p3,p1,p5,p4))
     & /(2*za(p3,p4)*zb(p3,p4)*zab2(p1,p2,p6,p5)*zab2(p6,p1,p5,p2))*((za(p1,p6)*delta2(p1,p5,p2,p6,p3,p4))/(za(p2,p6))
     & -(zb(p2,p5)*delta2(p2,p6,p1,p5,p3,p4))/(zb(p1,p5))
     & )
     & -(zb(p1,p4)*zb(p2,p6)*za(p1,p2)**2*za(p1,p3))
     & /(2*zb(p3,p4)*za(p1,p6)*za(p3,p4)*zab2(p1,p2,p6,p5)**2)*L0(-t(p1,p2,p6),-s(p2,p6))
     & -1._dp/2._dp*(zb(p2,p4)**2*za(p2,p5)**2*t(p2,p3,p4))
     & /(za(p1,p6)*s(p3,p4)**2*zb(p3,p4)*zab2(p6,p1,p5,p2))*L1(-t(p2,p3,p4),-s(p3,p4))
     & +(za(p5,p6)*zb(p4,p6))
     & /(za(p1,p6)*zb(p1,p5)*zb(p3,p4)*zab2(p6,p1,p5,p2))*((za(p5,p6)*zb(p1,p5)*zb(p4,p2))/(zab2(p6,p1,p5,p2))
     & -2*(zab2(p5,p1,p6,p4))/(za(p1,p5))
     & )
     &  *L0(-t(p1,p5,p6),-s(p1,p5))
     & +(zb(p2,p4))/(za(p1,p6)*zb(p3,p4)*zab2(p6,p1,p5,p2)*s(p3,p4))*((zab2(p5,p2,p3,p4)+zb(p1,p4)*za(p1,p5))*za(p2,p5)
     & +(za(p5,p6)*zab2(p2,p1,p5,p4)*zab2(p5,p1,p6,p2))/(zab2(p6,p1,p5,p2))
     & )
     &  *L0(-t(p2,p3,p4),-s(p3,p4))
     & +(za(p1,p2)*za(p3,p5))/(za(p1,p6)*za(p2,p6)*za(p3,p4)*zab2(p1,p2,p6,p5))*((zb(p4,p5)*za(p1,p2)*za(p3,p4))
     & /(zab2(p1,p2,p6,p5))
     & -(zab2(p2,p1,p6,p4))/(zb(p3,p4))
     & )
     &  *L0(-t(p3,p4,p5),-s(p3,p4))
     & -1._dp/2._dp*(zb(p4,p6)**2*za(p5,p6)**2*t(p1,p5,p6))
     & /(zb(p3,p4)*za(p1,p6)*s(p1,p5)**2*zab2(p6,p1,p5,p2))*L1(-t(p1,p5,p6),-s(p1,p5))
     & +1._dp/2._dp*(zb(p3,p4)*za(p1,p2)*za(p3,p5)**2*zab2(p2,p3,p4,p5))
     & /(za(p1,p6)*za(p2,p6)*s(p3,p4)**2*zab2(p1,p2,p6,p5))*L1(-t(p3,p4,p5),-s(p3,p4))
     & +Lnrat(-s(p1,p5),-s(p2,p6))*1._dp/(2*DeltaTM1526)*1._dp
     & /(zab2(p1,p2,p6,p5)*zab2(p6,p1,p5,p2))*(-12*zb(p1,p2)*za(p1,p2)*zb(p1,p6)*za(p1,p5)*zab2(p3,p1,p5,p4)
     & -10*zb(p1,p2)*za(p1,p2)*zb(p2,p6)*za(p2,p5)*zab2(p3,p1,p5,p4)
     & -3*(za(p1,p3)*zb(p1,p2)*za(p3,p5)*zab2(p2,p1,p5,p6)*(s(p1,p5)-s(p2,p6)-s(p3,p4)))/(za(p3,p4))
     & +3*(za(p1,p3)*zb(p2,p6)*za(p2,p3)*zab2(p5,p2,p6,p1)*(s(p1,p5)-s(p2,p6)))/(za(p3,p4))
     & -(zb(p2,p4)*za(p1,p5)*zab2(p2,p1,p5,p6)*zb(p1,p4)*(s(p1,p5)-s(p2,p6)))/(zb(p3,p4))
     & +(zb(p2,p4)*za(p1,p5)*zab2(p2,p1,p5,p6)*zb(p4,p5)*zab2(p5,p2,p6,p1))/(zb(p3,p4))
     & -3*(zb(p2,p4)*zb(p4,p6)*za(p1,p2)*zab2(p5,p2,p6,p1)*(s(p1,p5)-s(p2,p6)))/(zb(p3,p4))
     & -2*(zb(p4,p5)*zb(p4,p6)*za(p1,p5)*zab2(p5,p2,p6,p1)*(s(p1,p5)-s(p2,p6)))/(zb(p3,p4))
     & +8*zab(p3,p1,p4)*zab(p5,p1,p2)*zab2(p2,p1,p5,p6)
     & +6*zab(p3,p1,p4)*zab(p5,p6,p2)*zab2(p2,p1,p5,p6)
     & +6*zab(p3,p5,p4)*zab(p5,p1,p2)*zab2(p2,p1,p5,p6)
     & +2*zab(p3,p5,p4)*zab(p5,p6,p2)*zab2(p2,p1,p5,p6)
     & +zb(p1,p4)*zb(p2,p5)*za(p1,p5)*za(p3,p5)*zab2(p2,p1,p5,p6)
     & -2*zb(p1,p2)*zb(p4,p6)*za(p3,p5)*za(p2,p5)*zab2(p1,p2,p6,p5)
     & -8*zb(p1,p6)*zb(p4,p6)*za(p3,p5)*za(p5,p6)*zab2(p1,p2,p6,p5)
     & +2*zb(p4,p6)*za(p1,p3)*za(p1,p6)*zb(p1,p6)*zab2(p5,p2,p6,p1)
     & +zab2(p5,p2,p6,p1)*(2*zb(p4,p6)*za(p1,p3)*zab2(p1,p2,p5,p1)
     & +2*zb(p4,p6)*zab2(p1,p3,p4,p2)*za(p2,p3)
     & +6*zb(p4,p6)*za(p1,p6)*zab2(p3,p2,p5,p6)
     & -4*zb(p2,p4)*zab2(p1,p3,p4,p6)*za(p2,p3)
     & +za(p1,p2)*zb(p2,p6)*zab2(p3,p1,p5,p4))
     & +(zb(p2,p6)*za(p1,p3)*za(p3,p6)*zab2(p2,p1,p5,p6)*zab2(p5,p2,p6,p1))/(za(p3,p4))
     & -2*(zb(p2,p6)*za(p5,p6)*zab2(p3,p1,p5,p4)*(s(p1,p2)-s(p5,p6))*(t(p1,p2,p5)-t(p1,p5,p6)))/(zab2(p6,p1,p5,p2))
     & -2*(zb(p5,p6)*za(p1,p5)*zab2(p3,p1,p5,p4)*(s(p1,p2)-s(p5,p6))*(t(p1,p3,p4)-t(p3,p4,p5)))/(zab2(p1,p2,p6,p5))
     & )
     & +1._dp/(zab2(p6,p1,p5,p2))*((za(p1,p5)*zb(p1,p4)*zab2(p1,p2,p6,p4))/(zb(p3,p4)*za(p1,p6)*zab2(p1,p2,p6,p5))
     & -3._dp/2._dp*(zb(p1,p6)*za(p1,p3)*za(p3,p5))/(za(p3,p4)*zab2(p1,p2,p6,p5))
     & +3._dp/2._dp*(zab2(p5,p1,p6,p4)**2)/(zb(p3,p4)*za(p1,p6)*t(p2,p3,p4))
     & )
     &  *Lnrat(-s(p1,p5),-s(p2,p6))
     & +Lnrat(-s(p1,p5),-s(p3,p4))*1._dp/(2*DeltaTM1526)*1._dp
     & /(zab2(p1,p2,p6,p5)*zab2(p6,p1,p5,p2))*(-3*za(p1,p2)*za(p3,p5)*zb(p1,p2)*zb(p2,p4)*zab2(p2,p1,p5,p6)
     & -za(p1,p5)*zb(p1,p4)*zab2(p3,p4,p5,p2)*zab2(p2,p1,p5,p6)
     & -za(p1,p5)*za(p2,p5)*zb(p1,p5)*zb(p2,p6)*zab2(p3,p1,p5,p4)
     & +za(p1,p5)*za(p1,p6)*zb(p1,p6)**2*zab2(p3,p1,p5,p4)
     & +3*za(p1,p2)*za(p3,p5)*zb(p1,p6)*zb(p4,p6)*zab2(p6,p1,p5,p2)
     & +zab2(p5,p2,p6,p1)*(5*za(p1,p2)*za(p2,p3)*zb(p2,p4)*zb(p2,p6)
     & +5*za(p1,p5)*za(p3,p6)*zb(p4,p6)*zb(p5,p6)
     & +4*za(p1,p5)*za(p2,p3)*zb(p2,p4)*zb(p5,p6)
     & +za(p1,p6)*za(p3,p4)*zb(p4,p6)**2)
     & +(za(p1,p2)*za(p3,p6)*zb(p4,p6)*zab2(p5,p2,p6,p1)*(s(p1,p5)-s(p3,p4)))/(za(p2,p6))
     & -2*(za(p1,p2)*za(p2,p3)*zb(p2,p4)*zab2(p5,p2,p6,p1)*(s(p1,p5)-s(p3,p4)))/(za(p2,p6))
     & +(za(p1,p2)*zab2(p3,p1,p5,p4)*zab2(p5,p2,p6,p1)*zab2(p6,p1,p5,p6))/(za(p2,p6))
     & +3*(za(p1,p2)*za(p2,p5)*zb(p1,p2)*zab2(p3,p1,p5,p4)*(s(p1,p5)-s(p3,p4)))/(za(p2,p6))
     & +2*(za(p5,p6)*zab2(p2,p1,p5,p6)*zab2(p3,p1,p5,p4)*(s(p1,p5)-s(p3,p4)))/(za(p2,p6))
     & +2*(zab2(p3,p1,p5,p4)*zab2(p5,p3,p4,p2)*(s(p1,p2)-s(p5,p6))*(t(p1,p2,p5)-t(p1,p5,p6)))/(zab2(p6,p1,p5,p2))
     & )
     & +1._dp/(2*DeltaTM1526)*1._dp/(zab2(p1,p2,p6,p5)*zab2(p6,p1,p5,p2))*((zb(p1,p2))
     & /(zb(p1,p5))*(3*zb(p1,p4)*za(p3,p2)*za(p1,p5)*zb(p5,p6)*(s(p2,p6)-s(p3,p4))
     & -zab2(p2,p1,p5,p6)*zab2(p3,p1,p5,p4)*(t(p2,p5,p6)-s(p3,p4)))
     & +2*za(p3,p5)*zab2(p2,p1,p5,p6)*(zb(p1,p2)*zb(p2,p4)*za(p1,p2)
     & -3*zb(p1,p2)*zb(p3,p4)*za(p1,p3))
     & -3*zb(p1,p2)*zb(p4,p6)*za(p1,p2)*za(p3,p5)*(s(p1,p6)+s(p2,p6)-s(p3,p4))
     & -4*zb(p1,p2)*zb(p1,p4)*za(p1,p3)*za(p1,p5)*zab2(p2,p1,p5,p6)
     & -zb(p2,p4)*zb(p2,p5)*za(p2,p5)*za(p3,p5)*zab2(p2,p1,p5,p6)
     & -8*zb(p1,p2)*za(p1,p2)*za(p2,p5)*zb(p2,p6)*zab2(p3,p1,p5,p4)
     & +3*zb(p2,p4)*za(p1,p2)*zab2(p3,p4,p5,p6)*zab2(p5,p2,p6,p1)
     & -3*zb(p2,p4)*za(p1,p3)*za(p2,p5)*zb(p5,p6)*zab2(p5,p2,p6,p1)
     & +3*za(p2,p5)*zb(p2,p6)*zab2(p3,p1,p5,p4)*t(p1,p5,p6)
     & +za(p1,p5)*zb(p1,p6)*zab2(p3,p1,p5,p4)*(3*t(p2,p3,p4)-3*s(p3,p4)+3*s(p1,p2)+s(p1,p2)+s(p2,p6))
     & +zb(p2,p6)*zb(p2,p5)*za(p2,p5)**2*zab2(p3,p1,p5,p4)
     & +zb(p2,p6)*zb(p3,p4)*za(p1,p3)*za(p2,p3)*zab2(p5,p2,p6,p1)
     & -zb(p4,p6)*zab2(p2,p1,p5,p6)*za(p3,p5)*zab2(p6,p1,p5,p2)
     & -3*zb(p2,p5)*zb(p4,p6)*za(p1,p2)*za(p3,p5)*za(p5,p6)*zb(p1,p6)
     & -2*(zab2(p1,p3,p4,p6)*zab2(p3,p1,p5,p4))/(zab2(p1,p2,p6,p5))*(s(p1,p2)-s(p5,p6))*(t(p1,p3,p4)-t(p3,p4,p5))
     & )
     &  *Lnrat(-s(p3,p4),-s(p2,p6))
     & +(3*za(p1,p5)*zab2(p2,p1,p5,p6)*zab2(p3,p1,p5,p4)*zab2(p5,p2,p6,p1))
     & /(DeltaTM1526**2*zab2(p1,p2,p6,p5)*zab2(p6,p1,p5,p2))*(2*za(p1,p6)*zb(p1,p2)*zb(p5,p6)
     & +zb(p2,p5)*(s(p1,p2)+s(p2,p5)+s(p5,p6)-s(p1,p6))
     & )
     &  *Lnrat(-s(p1,p5),-s(p3,p4))
     & +(3*zb(p2,p6)*zab2(p2,p1,p5,p6)*zab2(p3,p1,p5,p4)*zab2(p5,p2,p6,p1))
     & /(DeltaTM1526**2*zab2(p1,p2,p6,p5)*zab2(p6,p1,p5,p2))*(2*za(p1,p2)*za(p5,p6)*zb(p2,p5)
     & +za(p1,p6)*(s(p1,p2)+s(p1,p6)+s(p5,p6)-s(p2,p5))
     & )
     &  *Lnrat(-s(p3,p4),-s(p2,p6))
     & +(zb(p4,p6))/(zab2(p6,p1,p5,p2))*((zb(p2,p4)*za(p5,p6)**2)/(zb(p3,p4)*za(p1,p6)*zab2(p6,p1,p5,p2))
     & +1._dp/2._dp*(za(p3,p5))/(zab2(p1,p2,p6,p5))
     & )
     &  *Lnrat(-s(p3,p4),-s(p2,p6))
     & +(za(p1,p2))/(za(p2,p6)*zb(p3,p4)*zab2(p1,p2,p6,p5)*zab2(p6,p1,p5,p2))*((zb(p4,p5)*zab2(p5,p1,p3,p4)*(s(p1,p2)-s(p5,p6)))
     & /(zab2(p1,p2,p6,p5))
     & -zb(p1,p4)*(zab(p5,p6,p4)+(zb(p2,p4)*za(p2,p5))/2._dp)
     & )
     &  *Lnrat(-t(p1,p2,p6),-s(p1,p5))
     & +(za(p1,p2)*zb(p1,p4))/(2*za(p1,p6)*zb(p3,p4)*zab2(p1,p2,p6,p5))*(3*(zb(p1,p2)*zab2(p1,p2,p3,p4))
     & /(zb(p1,p5)*zab2(p6,p1,p5,p2))
     & +(zb(p2,p4)*za(p1,p5))/(zab2(p6,p1,p5,p2))
     & +(zb(p2,p6)*za(p1,p2)*zb(p4,p5))/(zb(p1,p5)*zab2(p1,p2,p6,p5))
     & +(zb(p2,p6)*za(p1,p2)*za(p1,p3))/(za(p3,p4)*zab2(p1,p2,p6,p5))
     & +(zb(p4,p6))/(zb(p1,p5))
     & -(zab2(p3,p1,p2,p6))/(zb(p1,p5)*za(p3,p4))
     & -3*(za(p2,p3)*zb(p1,p6)*zab2(p5,p2,p3,p4)*zab2(p1,p2,p6,p5))/(za(p1,p2)*za(p3,p4)*zb(p1,p4)*zb(p1,p5)*t(p2,p3,p4))
     & )
     &  *Lnrat(-t(p1,p2,p6),-s(p2,p6))
     & +(za(p1,p2))/(za(p2,p6)*zab2(p1,p2,p6,p5)*zab2(p6,p1,p5,p2))*(-3._dp/2._dp*(zb(p1,p2)*zb(p1,p4)*za(p2,p3))/(zb(p1,p5))
     & +(zb(p1,p4)*za(p1,p3)*(s(p1,p2)-s(p5,p6)))/(zab2(p1,p2,p6,p5))
     & -(zb(p4,p5)*za(p3,p5)*za(p5,p6))/(za(p1,p6))
     & )
     &  *Lnrat(-t(p1,p2,p6),-s(p3,p4))
     & -3._dp/2._dp*(zab2(p5,p1,p6,p4)**2)/(zb(p3,p4)*za(p1,p6)*zab2(p6,p1,p5,p2)*t(p2,p3,p4))*Lnrat(-t(p1,p5,p6),-s(p3,p4))
     & +1._dp/(2*za(p1,p6)*zb(p3,p4))*(-(zab2(p5,p1,p6,p4)*zb(p4,p6)*za(p5,p6))/(za(p1,p5)*zb(p1,p5)*zab2(p6,p1,p5,p2))
     & -(zb(p1,p4)*za(p1,p3)*za(p2,p5)*zab2(p2,p1,p6,p5))/(zb(p1,p5)*za(p2,p6)*za(p3,p4)*zab2(p1,p2,p6,p5))
     & +(zb(p1,p6)*za(p2,p3)*za(p3,p6)*za(p5,p6)*zb(p3,p4))/(zb(p1,p5)*za(p2,p6)*za(p3,p4)*zab2(p6,p1,p5,p2))
     & +(zb(p1,p6)*za(p2,p3)*zab2(p5,p1,p6,p4))/(zb(p1,p5)*za(p3,p4)*t(p2,p3,p4))
     & -(zb(p2,p4)*za(p2,p5)**2*zab2(p6,p1,p5,p4))/(za(p2,p6)*s(p3,p4)*zab2(p6,p1,p5,p2))
     & -(za(p1,p6)*zb(p4,p5)*za(p3,p6)*zab2(p2,p1,p5,p6)*zab2(p5,p2,p6,p1))
     & /(zb(p1,p5)*za(p2,p6)*za(p3,p4)*zab2(p1,p2,p6,p5)*zab2(p6,p1,p5,p2))
     & +(zb(p3,p4)*za(p1,p2)*za(p2,p3)*za(p3,p5))/(za(p2,p6)*za(p3,p4)*zab2(p1,p2,p6,p5))
     & )
     & )

      return
      end
